/******************************************************************************
*                                                                             *
*    DTUtil.as                              Copyright(c) 2003-2009 itow,y.    *
*                                                                             *
******************************************************************************/

/******************************************************************************

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

******************************************************************************/


#uselib "DTUtil.hpi"

#func MultiplyDivide	MultiplyDivide		1

#func StartTimeCount	StartTimeCount		0
#func GetTimeCount	GetTimeCount		1
#func StopTimeCount	StopTimeCount		0
#func RestartTimeCount	RestartTimeCount	0

#func SetPixelizeSrc	SetPixelizeSrc		2
#func Pixelize		Pixelize		2

#func SetFadeMode	SetFadeMode		2
#func Fade		Fade			0

#func FileOpenDialog	FileOpenDialog		0x202


#define OFN_READONLY                 0x00000001
#define OFN_OVERWRITEPROMPT          0x00000002
#define OFN_HIDEREADONLY             0x00000004
#define OFN_NOCHANGEDIR              0x00000008
#define OFN_SHOWHELP                 0x00000010
;#define OFN_ENABLEHOOK               0x00000020
;#define OFN_ENABLETEMPLATE           0x00000040
;#define OFN_ENABLETEMPLATEHANDLE     0x00000080
#define OFN_NOVALIDATE               0x00000100
;#define OFN_ALLOWMULTISELECT         0x00000200
#define OFN_EXTENSIONDIFFERENT       0x00000400
#define OFN_PATHMUSTEXIST            0x00000800
#define OFN_FILEMUSTEXIST            0x00001000
#define OFN_CREATEPROMPT             0x00002000
#define OFN_SHAREAWARE               0x00004000
#define OFN_NOREADONLYRETURN         0x00008000
#define OFN_NOTESTFILECREATE         0x00010000
#define OFN_NONETWORKBUTTON          0x00020000
#define OFN_NOLONGNAMES              0x00040000
#define OFN_EXPLORER                 0x00080000
#define OFN_NODEREFERENCELINKS       0x00100000
#define OFN_LONGNAMES                0x00200000
#define OFN_ENABLEINCLUDENOTIFY      0x00400000
#define OFN_ENABLESIZING             0x00800000
#define OFN_DONTADDTORECENT          0x02000000
#define OFN_FORCESHOWHIDDEN          0x10000000


#module

#deffunc PixelizeCopy int,int,int
	mref SrcBuf,0
	mref w,1:mref h,2

	ginfo 1:CurBuf=prmy
	gsel SrcBuf
	SetPixelizeSrc@
	gsel CurBuf
	Pixelize@ w,h
	return

#deffunc FadeImage int,int,int,int,int
	mref op,0:mref l,1:mref t,2:mref w,3:mref h,4

	SetFadeMode@ op
	Fade@ l,t,w,h
	return

#global
