;ǂڂ炽 ver.1.0.0
;Copyright(c) 2003-2009 itow,y.

;for HSP ver.2.6

/******************************************************************************

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

******************************************************************************/


#packopt name "DvoraType"
#packopt xsize 640
#packopt ysize 480
#packopt hide 1
#pack "back.jpg"
#pack "balloon.mag"
#pack "char.mag"
#pack "charfrm.mag"
#pack "endmenu.mag"
#pack "font.bmp"
#pack "hand.mag"
#pack "keyboard.mag"
#pack "menu_frm.mag"
#pack "menu_str.mag"
#pack "messages.mag"
#pack "mmenu_f.mag"
#pack "mmenu_s.mag"
#pack "dic.dat"


#include "DTUtil.as"


#define TRUE	1
#define FALSE	0

#define MAX_PATH	260

#define VK_LBUTTON	0x01
#define VK_TAB		0x09
#define VK_RETURN	0x0D
#define VK_SHIFT	0x10
#define VK_CTRL		0x11
#define VK_ESCAPE	0x1B
#define VK_SPACE	0x20
#define VK_LEFT		0x25
#define VK_UP		0x26
#define VK_RIGHT	0x27
#define VK_DOWN		0x28


#define INT_SIZE	4


#define APPNAME "ǂڂ炽"
#define VERSIONNAME "1.0.0"

#define Left	0
#define Top		1

#define WID_WINDOW		0
#define WID_FULLSCREEN	12

#define BF_BACKGROUND	2
#define BF_MAINMENU		3
#define BF_MENU			4
#define BF_ENDMENU		5
#define BF_FONT			6
#define BF_KEYBOARD 	7
#define BF_HAND			8
#define BF_MESSAGES		9
#define BF_CHARACTER	10
#define BF_TEMP			11

#define BASIC_MENU_POS		120
#define TRIAL_MENU_POS		440
#define OPTIONS_MENU_POS	680

#define COLORMODE	0

#define WINDOW_WIDTH	640
#define WINDOW_HEIGHT	480

#define WMODE_WINDOW		0
#define WMODE_FULLSCREEN	1

#define FONT_WIDTH	32
#define FONT_HEIGHT	32

#define MAX_WORD_LENGTH	15

#define MAX_HISTORY	100

#define TIMETRIAL_NUM_LEVELS	6

#define CHAR_NORMAL	0
#define CHAR_GOOD	1
#define CHAR_BEST	2
#define CHAR_BAD	3

#define LESSON_END		0
#define LESSON_BREAK	1
#define LESSON_RESTART	2

#define MAX_MENU_ANI_CNT	23

#define DEFAULT_WALLPAPER_NAME	"back.jpg"

#define SB_BGM			0
#define SB_MENUSELECTED	1
#define SB_WORDTYPED	2
#define SB_MISSTYPED	3
#define SB_TIMEUP		4

#define BGM_NAME	"bgm.mid"

#define WCTYPE_WORD		0
#define WCTYPE_LETTER	1


;CalcCorrectness Result,Correct,Miss
#define CalcCorrectness(%1,%2,%3) %1=(%2*100000/(%2+%3)+5)/10
;CalcAverage Result,Letters,Time
;ȉƃI[o[t[
;#define CalcAverage(%1,%2,%3) %1=(%2*6000000/%3+5)/10
#define CalcAverage(%1,%2,%3)  MultiplyDivide %1,%2,6000000,%3:%1=(%1+5)/10


#module

#deffunc DrawMessage str
	mref MesStr,32
	gsel 0
	redraw 0
	gmode 1
	pos 32,24:gcopy BF_BACKGROUND@,32,24,456,32
	if MesStr!=""{
		color 128,128,128
		font "lr oSVbN",16,1
		pos 32,24:mes MesStr
	}
	redraw 1,32,24,456,32
	return

#deffunc GetCurMessage val
	mref s,24
	s=MesStr
	return

#global


	if (COLORMODE=0) & paluse{
		dialog {"̃vÓApbg[hł͐삵܂B
			ʂ̐FnCJ[yуgD[J[ɂĂB"},0,APPNAME
		end
	}


	onexit *Exit


	sdim HomeDir,MAX_PATH
	if hspstat&1:HomeDir=curdir:else:HomeDir=exedir


	sdim ScoreFileName,MAX_PATH
	sdim WallPaperName,MAX_PATH

	sdim s,512

	if cmdline!=""{
		sdim tmp,1024:tmp=cmdline
		i=0
		repeat
		peek n,tmp,i:if n=0{break}
		if n!=' '{
			if n='"'{
				i++:getstr s,tmp,i,'"'
			}else{
				getstr s,tmp,i,' '
			}
			i+=strsize-1
			peek n,s,0
			if (n='/') | (n='-'){
				peek n,s,1
				if (n='s') | (n='S'){
					getstr ScoreFileName,s,2
				}
				if (n='w') | (n='W'){
					getstr WallPaperName,s,2
				}
			}
		}else{
			i++
		}
		loop
	}

	if ScoreFileName!=""{
		repeat
		peek n,ScoreFileName,cnt
		if n=0{
			ScoreFileName=HomeDir+"\\"+ScoreFileName
			break
		}
		if ((n>=0x81) & (n<=0x9F)) | ((n>=0xE0) & (n<=0xFC)){
			continue cnt+2
		}
		if n="\\"{break}
		loop
	}else{
		ScoreFileName=HomeDir+"\\score"
	}


	ginfo 5
	MainWindow.Left=dispx-(prmx-winx+WINDOW_WIDTH)/2
	MainWindow.Top=dispy-(prmy-winy+WINDOW_HEIGHT)/2

	if (dispx>WINDOW_WIDTH) & (dispy>WINDOW_HEIGHT){
		FullScreenOnly=FALSE
		WindowMode=WMODE_WINDOW
	}else{
		FullScreenOnly=TRUE
		WindowMode=WMODE_FULLSCREEN
	}

	sdim IniWallPaperName,MAX_PATH

	WallPaperFilterIndex=1

	Sound=TRUE
	Music=FALSE

#define TH_RIGHT	0
#define TH_LEFT		1
	TypeHand6=TH_RIGHT

	MenuOpacity=224

	gosub *LoadSettings

	ginfo 5
	if MainWindow.Left+(prmx-winx+WINDOW_WIDTH)>dispx{
		MainWindow.Left=dispx-(prmx-winx+WINDOW_WIDTH)
	}
	if MainWindow.Top+(prmy-winy+WINDOW_HEIGHT)>dispy{
		MainWindow.Top=dispy-(prmy-winy+WINDOW_HEIGHT)
	}

	if (WallPaperName="") & (IniWallPaperName!=""){
		WallPaperName=IniWallPaperName
	}

	if MenuOpacity<64:MenuOpacity=64
	if MenuOpacity>256:MenuOpacity=256


	buffer BF_TEMP,4,1,COLORMODE
	if WallPaperName!=""{
		exist WallPaperName
		if strsize>=0{skiperr 1:picload WallPaperName:skiperr 0}
		if strsize<0 | err{
			if strsize<0{
				dialog WallPaperName+{"
					\nw肳ꂽ摜܂B"},0,"G["
			}else{
				dialog WallPaperName+{"
					\nw肳ꂽ摜ǂݍ߂܂B"},0,"G["
			}
			if (IniWallPaperName="") | (IniWallPaperName=WallPaperName){
				picload DEFAULT_WALLPAPER_NAME
			}else{
				exist IniWallPaperName
				if strsize>=0{
					WallPaperName=IniWallPaperName
					skiperr 1:picload WallPaperName:skiperr 0
					if err{
						dialog WallPaperName+{"
							\nw肳ꂽ摜ǂݍ߂܂B"},0,"G["
						picload DEFAULT_WALLPAPER_NAME
					}
				}else{
					dialog IniWallPaperName+{"
						\nw肳ꂽ摜܂B"},0,"G["
					picload DEFAULT_WALLPAPER_NAME
				}
			}
		}
	}else{
		picload DEFAULT_WALLPAPER_NAME
	}
	gosub *MakeBackgroundImage

	buffer BF_CHARACTER,88,448,COLORMODE
	picload "char.mag",1
	gsel BF_BACKGROUND
	CurCharImage=CHAR_NORMAL
	gosub *DrawCharacter

	if (WindowMode=WMODE_FULLSCREEN) & ((dispx!=640) | (dispy!=480)){
		chgdisp 1
		if stat{
			if stat=1{
				chgdisp
				dialog "tJ[[hɂł܂łB",0,"G["
			}else{
				dialog "𑜓x̕ύXł܂łB",0,"G["
			}
			if FullScreenOnly:end
			WindowMode=WMODE_WINDOW
		}
	}
	if WindowMode=WMODE_WINDOW{
		MainWindowID=WID_WINDOW
	}else{
		MainWindowID=WID_FULLSCREEN
	}

	gosub *MainWindowInit

	n=100
	repeat 10
	PixelizeCopy BF_BACKGROUND,n,n
	n-=10
	redraw 1
	await 100
	loop

	gmode 1
	pos 0,0:gcopy BF_BACKGROUND,0,0,WINDOW_WIDTH,WINDOW_HEIGHT


	buffer BF_TEMP,384,128,COLORMODE:picload "mmenu_f.mag",1
	buffer BF_MAINMENU,384,768,COLORMODE
	gmode 1
	repeat 6
	pos 0,cnt*128:gcopy BF_TEMP,0,0,384,128
	loop
	buffer BF_TEMP,352,384,COLORMODE:picload "mmenu_s.mag",1
	gsel BF_MAINMENU
	i=0
	repeat 6
		repeat 3
		pos cnt*128+6,i*128+32:gcopy BF_TEMP,cnt*116,i*64,116,64
		loop
	i++
	loop

	buffer BF_TEMP,768,40,COLORMODE:picload "menu_frm.mag",1
	buffer BF_MENU,768,920,COLORMODE
	gmode 1
	repeat 23
	pos 0,cnt*40:gcopy BF_TEMP,0,0,768,40
	loop
	buffer BF_TEMP,720,690,COLORMODE:picload "menu_str.mag",1
	gsel BF_MENU
	i=0
	repeat 23
		repeat 3
		pos cnt*256+8,i*40+5:gcopy BF_TEMP,cnt*240,i*30,240,30
		loop
	i++
	loop
	buffer BF_TEMP,4,1,COLORMODE

	buffer BF_ENDMENU,288,288,COLORMODE
	picload "endmenu.mag",1

	buffer BF_FONT,FONT_WIDTH*95,FONT_HEIGHT*3,COLORMODE
	picload "font.bmp",1

	buffer BF_KEYBOARD,480,320,COLORMODE
	picload "keyboard.mag",1

	buffer BF_HAND,160,112,COLORMODE
	picload "hand.mag",1

	buffer BF_MESSAGES,336,344,COLORMODE
	picload "messages.mag",1


	sdim TypeWords,2048

	sdim CurWord,MAX_WORD_LENGTH+4
	dim CurWord_CharCode,MAX_WORD_LENGTH
	dim CurWord_KeyCode,MAX_WORD_LENGTH

	dim MissTypedKey,95


	dim TimeTrialRanking_Score,TIMETRIAL_NUM_LEVELS,10
	dim TimeTrialRanking_Correctness,TIMETRIAL_NUM_LEVELS,10
	dim TimeTrialRanking_Date,TIMETRIAL_NUM_LEVELS,10

	LetterLessonHistoryCnt=0
	dim LetterLessonHistory_Speed,MAX_HISTORY
	dim LetterLessonHistory_Correctness,MAX_HISTORY
	WordLessonHistoryCnt=0
	dim WordLessonHistory_Speed,MAX_HISTORY
	dim WordLessonHistory_Correctness,MAX_HISTORY

	gosub *LoadScore


	dim SoundLoaded,5
	if Sound:gosub *LoadSounds
	if Music{
		gosub *LoadMusic
		if SoundLoaded.SB_BGM{
			snd SB_BGM
		}else{
			Music=FALSE
		}
	}


	exist "dic.dat"
	sdim WordsDic,strsize+1
	bload "dic.dat",WordsDic
	notesel WordsDic:notemax DicWordsNum

	dim CharKeyCode,95
	CharKeyCode.0x00=0x20,0x31,0x32,0x33,0x34,0x35,0x36,0x37
	CharKeyCode.0x08=0x38,0x39,0xBA,0xBB,0xBC,0xBD,0xBE,0xBF
	CharKeyCode.0x10=0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37
	CharKeyCode.0x18=0x38,0x39,0xBA,0xBB,0xBC,0xBD,0xBE,0xBF
	CharKeyCode.0x20=0xC0,0x41,0x42,0x43,0x44,0x45,0x46,0x47
	CharKeyCode.0x28=0x48,0x49,0x4A,0x4B,0x4C,0x4D,0x4E,0x4F
	CharKeyCode.0x30=0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57
	CharKeyCode.0x38=0x58,0x59,0x5A,0xDB,0xDC,0xDD,0xDE,0xE2
	CharKeyCode.0x40=0xC0,0x41,0x42,0x43,0x44,0x45,0x46,0x47
	CharKeyCode.0x48=0x48,0x49,0x4A,0x4B,0x4C,0x4D,0x4E,0x4F
	CharKeyCode.0x50=0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57
	CharKeyCode.0x58=0x58,0x59,0x5A,0xDB,0xDC,0xDD,0xDE

	dim CharKeyBoardPos,2,95
	CharKeyBoardPos.0.0x00= 0, 4 ,  0, 0 ,  1, 0 ,  2, 0 ,  3, 0 ,  4, 0 ,  5, 0 ,  6, 0
	CharKeyBoardPos.0.0x08= 7, 0 ,  8, 0 ,  0, 1 ,  0, 3 ,  1, 1 , 10, 2 ,  2, 1 , 10, 1
	CharKeyBoardPos.0.0x10= 9, 0 ,  0, 0 ,  1, 0 ,  2, 0 ,  3, 0 ,  4, 0 ,  5, 0 ,  6, 0
	CharKeyBoardPos.0.0x18= 7, 0 ,  8, 0 ,  0, 1 ,  0, 3 ,  1, 1 , 10, 2 ,  2, 1 , 10, 1
	CharKeyBoardPos.0.0x20=11, 1 ,  0, 2 ,  5, 3 ,  7, 1 ,  5, 2 ,  2, 2 ,  5, 1 ,  6, 1
	CharKeyBoardPos.0.0x28= 6, 2 ,  4, 2 ,  2, 3 ,  3, 3 ,  9, 1 ,  6, 3 ,  8, 2 ,  1, 2
	CharKeyBoardPos.0.0x30= 3, 1 ,  1, 3 ,  8, 1 ,  9, 2 ,  7, 2 ,  3, 2 ,  8, 3 ,  7, 3
	CharKeyBoardPos.0.0x38= 4, 3 ,  4, 1 ,  9, 3 , 10, 0 , 12, 0 , 11, 0 , 11, 2 , 10, 3
	CharKeyBoardPos.0.0x40=11, 1 ,  0, 2 ,  5, 3 ,  7, 1 ,  5, 2 ,  2, 2 ,  5, 1 ,  6, 1
	CharKeyBoardPos.0.0x48= 6, 2 ,  4, 2 ,  2, 3 ,  3, 3 ,  9, 1 ,  6, 3 ,  8, 2 ,  1, 2
	CharKeyBoardPos.0.0x50= 3, 1 ,  1, 3 ,  8, 1 ,  9, 2 ,  7, 2 ,  3, 2 ,  8, 3 ,  7, 3
	CharKeyBoardPos.0.0x58= 4, 3 ,  4, 1 ,  9, 3 , 10, 0 , 12, 0 , 11, 0 , 11, 2

	dim MenuItemAniPos,MAX_MENU_ANI_CNT+1
	MenuItemAniPos=0,1,2,3,3,4,4,4,3,3,2,1,0,-1,-2,-3,-3,-4,-4,-4,-3,-3,-2,-1


	randomize


	gsel MainWindowID

	color
	n=20
	y.1=0,0,0
	repeat n
	redraw 0
	if cnt{
		gmode 1
		pos 40,y:gcopy BF_BACKGROUND,40,y,448,y.1
	}
	y=480-(352*(cnt+1)/n)
	if y.1<288{
		y.1=480-y:if y.1>288{y.1=288}
	}
	if y.2<128{
		y.2=y.1:if y.2>128{y.2=128}
	}
	if (y.3<128) & (y.1>160){
		y.3=y.1-160;:if y.3>128{y.3=128}
	}
	gmode 4,,,cnt+1*MenuOpacity/n
		repeat 3
		pos cnt\3*160+40,y
		gcopy BF_MAINMENU,0,cnt*128,128,y.2
		loop
	if y.3>0{
		repeat 3
		pos cnt\3*160+40,y+160
		gcopy BF_MAINMENU,0,cnt+3*128,128,y.3
		loop
	}
	redraw 1,40,y,448,480-y
	await 50
	loop

	CurMainMenuItem=0
	gosub *MainMenuItem_Focus

*MainMenu
	mx=-1:my=-1
	CurKey=0
	BlinkCnt=0

	repeat
	await 50

	stick n,0x0405,1
	if n&0x130:break	;Space or Enter or LButton
	if n&0x80{			;Esc
		gosub *MainMenuItem_UnFocus
		CurMainMenuItem=5
		break
	}
	SelMenuItem=CurMainMenuItem
	if n&0x05=0x01{	;Left and !Right
		if CurKey&0x01{KeyRepeatCnt++}else{CurKey=CurKey|0x01:KeyRepeatCnt=0}
		if KeyRepeatCnt\3=0{
			if (SelMenuItem\3>=1) & (SelMenuItem\3<=2){
				SelMenuItem--
			}
		}
	}else{
		if CurKey&0x01{CurKey=CurKey^0x01}
	}
	if n&0x05=0x04{	;Right and !Left
		if CurKey&0x04{KeyRepeatCnt++}else{CurKey=CurKey|0x04:KeyRepeatCnt=0}
		if KeyRepeatCnt\3=0{
			if (SelMenuItem\3>=0) & (SelMenuItem\3<=1){
				SelMenuItem++
			}
		}
	}else{
		if CurKey&0x04{CurKey=CurKey^0x04}
	}
	if n&0x0A=0x02{	;Up and !Down
		CurKey=CurKey|0x02
		if SelMenuItem>=3{
			SelMenuItem-=3
		}
	}else{
		if CurKey&0x02{CurKey=CurKey^0x02}
	}
	if n&0x0A=0x08{	;Down and !Up
		CurKey=CurKey|0x08
		if SelMenuItem<=2{
			SelMenuItem+=3
		}
	}else{
		if CurKey&0x08{CurKey=CurKey^0x08}
	}
	if n=0x400{	;Tab
		if CurKey&0x400{KeyRepeatCnt++}else{CurKey=CurKey|0x400:KeyRepeatCnt=0}
		if KeyRepeatCnt\3=0{
			SelMenuItem=SelMenuItem+1\6
		}
	}else{
		if CurKey&0x400{CurKey=CurKey^0x400}
	}

	if (mousex!=mx) | (mousey!=my){
		i=-1
		repeat 6
		x=cnt\3*160+40:y=cnt/3*160+128
		if (mousex>=x) & (mousex<(x+128)) & (mousey>=y) & (mousey<(y+128)){
			i=cnt:break
		}
		loop
		if (i>=0) & (i!=SelMenuItem){
			SelMenuItem=i
		}
		mx=mousex:my=mousey
	}

	if SelMenuItem!=CurMainMenuItem{
		gosub *MainMenuItem_UnFocus
		CurMainMenuItem=SelMenuItem
		gosub *MainMenuItem_Focus
	}else{
		redraw 0
		gmode 1
		x=CurMainMenuItem\3*160+40:y=CurMainMenuItem/3*160+128+MenuItemAniPos.j
		pos x,y:gcopy BF_BACKGROUND,x,y,128,128
		if j<MAX_MENU_ANI_CNT{j++}else{j=0}
		gmode 4,,,MenuOpacity:color
		y=CurMainMenuItem/3*160+128+MenuItemAniPos.j
		pos x,y:gcopy BF_MAINMENU,128,CurMainMenuItem*128,128,128
		redraw 1,x,y-1,128,130
	}

	if BlinkCnt=0{
		rnd n,100
		if n=0{
			gosub *BlinkCharacter
			BlinkCnt=1
		}
	}else{
		BlinkCnt++
		if BlinkCnt=3{
			gosub *DrawCharacter
			BlinkCnt=0
		}
	}
	loop

	if BlinkCnt>0:gosub *DrawCharacter

	redraw 0
	x=CurMainMenuItem\3*160+40:y=CurMainMenuItem/3*160+128
	gmode 1
	pos x,y-4:gcopy BF_BACKGROUND,x,y-4,128,136
	gmode 4,,,MenuOpacity
	color
	pos x,y:gcopy BF_MAINMENU,256,CurMainMenuItem*128,128,128
	redraw 1,x,y-4,128,136

	if Sound & SoundLoaded.SB_MENUSELECTED:snd SB_MENUSELECTED

	repeat 4
	redraw 0
	gmode 1
		repeat 6
		if cnt!=CurMainMenuItem{
			x=cnt\3*160+40:y=cnt/3*160+128
			pos x,y:gcopy BF_BACKGROUND,x,y,128,128
		}
		loop
	if cnt<=2{
		gmode 4,,,MenuOpacity*(3-cnt)/4
		repeat 6
		if cnt!=CurMainMenuItem{
			pos cnt\3*160+40,cnt/3*160+128
			gcopy BF_MAINMENU,0,cnt*128,128,128
		}
		loop
	}
	redraw 1,40,128,448,288
	await 50
	loop

	wait 10

	if CurMainMenuItem=5:goto *SelectedExitMenu

	x=CurMainMenuItem\3*160+40:x.1=x
	y=CurMainMenuItem/3*160+128:y.1=y
	n=x-24+(y-80)/32
	repeat n
	redraw 0
	gmode 1
	pos x.1,y.1:gcopy BF_BACKGROUND,x.1,y.1,128,128
	x.1=x-(x-24*(cnt+1)/n)
	y.1=y-(y-80*(cnt+1)/n)
	gmode 4,,,MenuOpacity
	pos x.1,y.1:gcopy BF_MAINMENU,256,CurMainMenuItem*128,128,128
	redraw 1
	await 50
	loop
	pos 24,80
	gmode 3,,,128:gcopy BF_BACKGROUND,24,80,128,128
	await 50

	if CurMainMenuItem=0{
		CurBasicLessonMenuItem=0
		goto *BasicLesson
	}
	if CurMainMenuItem=1{goto *LetterLesson}
	if CurMainMenuItem=2{goto *WordLesson}
	if CurMainMenuItem=3{
		CurTimeTrialMenuItem=0
		goto *TimeTrial
	}
	if CurMainMenuItem=4{
		CurOptionMenuItem=0
		goto *Options
	}

*SelectedExitMenu
	CurCharImage=CHAR_GOOD:gosub *DrawCharacter
	DrawMessage "܂KĂˁB"

	wait 100

	gsel BF_BACKGROUND
	pos 0,0:gcopy 0,0,MainWindowID,WINDOW_WIDTH,WINDOW_HEIGHT
	gsel MainWindowID
	n=10
	repeat 10
	PixelizeCopy BF_BACKGROUND,n,n
	n+=10
	redraw 1
	await 100
	loop

	goto *Exit

*MainMenuItem_UnFocus
	redraw 0
	x=CurMainMenuItem\3*160+40:y=CurMainMenuItem/3*160+128
	gmode 1
	pos x,y-4:gcopy BF_BACKGROUND,x,y-4,128,136
	gmode 4,,,MenuOpacity:color
	pos x,y:gcopy BF_MAINMENU,0,CurMainMenuItem*128,128,128
	redraw 1,x,y-4,128,136
	return

*MainMenuItem_Focus
	redraw 0
	x=CurMainMenuItem\3*160+40:y=CurMainMenuItem/3*160+128
	pos x,y
	gmode 1
	gcopy BF_BACKGROUND,x,y,128,128
	gmode 4,,,MenuOpacity:color
	gcopy BF_MAINMENU,128,CurMainMenuItem*128,128,128
	redraw 1,x,y,128,128
	if CurMainMenuItem=0{
		DrawMessage {"bIȗK܂B
			܂͂ŃL[zoĂˁB"}
	}
	if CurMainMenuItem=1{
		DrawMessage "1PʂőłK܂B"
	}
	if CurMainMenuItem=2{
		DrawMessage "PłK܂B"
	}
	if CurMainMenuItem=3{
		DrawMessage {"܂ԂɉłĂ邩킵܂B
			łĂ΃LOɓ܂B"}
	}
	if CurMainMenuItem=4{
		DrawMessage "ݒύX܂B"
	}
	if CurMainMenuItem=5{
		DrawMessage APPNAME+"Iɂ܂B"
	}
	j=0
	return

*ReturnMainMenu
	color
	n=20
	y.1=0,0,0
	x=24:y.4=80
	repeat n
	redraw 0
	if cnt{
		gmode 1
		pos 40,y:gcopy BF_BACKGROUND,40,y,448,y.1
	}
	pos x,y.4:gcopy BF_BACKGROUND,x,y.4,128,128
	y=480-(352*(cnt+1)/n)
	if y.1<288{
		y.1=480-y:if y.1>288{y.1=288}
	}
	if y.2<128{
		y.2=y.1:if y.2>128{y.2=128}
	}
	if (y.3<128) & (y.1>160){
		y.3=y.1-160;:if y.3>128{y.3=128}
	}
	gmode 4,,,cnt+1*MenuOpacity/n
		repeat 3
		if cnt!=CurMainMenuItem{
			pos cnt\3*160+40,y
			gcopy BF_MAINMENU,0,cnt*128,128,y.2
		}
		loop
	if y.3>0{
		repeat 3
		if cnt+3!=CurMainMenuItem{
			pos cnt\3*160+40,y+160
			gcopy BF_MAINMENU,0,cnt+3*128,128,y.3
		}
		loop
	}
	x=CurMainMenuItem\3*160+16*(cnt+1)/n+24
	y.4=CurMainMenuItem/3*160+48*(cnt+1)/n+80
	gmode 4,,,(MenuOpacity-(MenuOpacity/2))*(cnt+1)/20+(MenuOpacity/2)
	pos x,y.4:gcopy BF_MAINMENU,256,CurMainMenuItem*128,128,128
	redraw 1,24,80,464,400
	await 50
	loop

	gosub *MainMenuItem_Focus

	goto *MainMenu



*BasicLesson
	color
	x=0,0
	x.3=0
	n=16
	repeat n
	redraw 0
	if cnt{
		gmode 1
		pos x,98:gcopy BF_BACKGROUND,x,98,x.1,348
		pos x.2,368:gcopy BF_BACKGROUND,x.2,368,x.3,96
	}
	pos 24,80
	gcopy BF_BACKGROUND,24,80,128,128
	gmode 4,,,MenuOpacity/2
	gcopy BF_MAINMENU,256,CurMainMenuItem*128,128,128
	gmode 4,,,MenuOpacity*(cnt+1)/n
	if x.1<256{
		x.1=456*(cnt+1)/n:if x.1>256{x=x.1-256:x.1=256}
	}else{
		x=456*(cnt+1)/n-256
	}
		repeat 8
		pos x,cnt*44+98
		gcopy BF_MENU,256-x.1,cnt*40+BASIC_MENU_POS,x.1,40
		loop
	x.2=640-(112*(cnt+1)/n)
	if x.3<96{
		x.3=640-x.2:if x.3>96{x.3=96}
	}
	pos x.2,368:gcopy BF_ENDMENU,0,192,x.3,96
	redraw 1
	await 50
	loop

	CurMenuItem=CurBasicLessonMenuItem
	gosub *BasicLessonMenuItem_Focus

	CurKey=0
	mx=-1:my=-1
	BlinkCnt=0

	repeat
	await 50

	stick n,0x040A,1
	if n&0x130:break	;Space or Enter or LButton
	if n&0x80{			;Esc
		gosub *BasicLessonMenuItem_UnFocus
		CurMenuItem=8
		break
	}
	SelMenuItem=CurMenuItem
	if n&0x0A=0x02{	;Up and !Down
		if CurKey&0x02{KeyRepeatCnt++}else{CurKey=CurKey|0x02:KeyRepeatCnt=0}
		if KeyRepeatCnt\3=0{
			if (SelMenuItem>=1) & (SelMenuItem<=7){
				SelMenuItem--
			}
		}
	}else{
		if CurKey&0x02{CurKey=CurKey^0x02}
	}
	if n&0x0A=0x08{	;Down and !Up
		if CurKey&0x08{KeyRepeatCnt++}else{CurKey=CurKey|0x08:KeyRepeatCnt=0}
		if KeyRepeatCnt\3=0{
			if SelMenuItem<=6{
				SelMenuItem++
			}
		}
	}else{
		if CurKey&0x08{CurKey=CurKey^0x08}
	}
	if n&0x05=0x01{	;Left and !Right
		CurKey=CurKey|0x01
		if SelMenuItem=8{
			SelMenuItem=CurBasicLessonMenuItem
		}
	}else{
		if CurKey&0x01{CurKey=CurKey^0x01}
	}
	if n&0x05=0x04{	;Right and !Left
		CurKey=CurKey|0x04
		if SelMenuItem<=7{
			SelMenuItem=8
		}
	}else{
		if CurKey&0x04{CurKey=CurKey^0x04}
	}
	if n=0x400{		;Tab
		if CurKey&0x400{KeyRepeatCnt++}else{CurKey=CurKey|0x400:KeyRepeatCnt=0}
		if KeyRepeatCnt\3=0{
			SelMenuItem=SelMenuItem+1\9
		}
	}else{
		if CurKey&0x400{CurKey=CurKey^0x400}
	}

	if (mousex!=mx) | (mousey!=my){
		i=-1
		repeat 8
		y=cnt*44+98
		if (mousex>=200) & (mousex<456) & (mousey>=y) & (mousey<(y+40)){
			i=cnt:break
		}
		loop
		if i<0{
			if (mousex>=528) & (mousex<624) & (mousey>=368) & (mousey<464){
				i=8
			}
		}
		if (i>=0) & (i!=SelMenuItem){
			SelMenuItem=i
		}
		mx=mousex:my=mousey
	}

	if SelMenuItem!=CurMenuItem{
		gosub *BasicLessonMenuItem_UnFocus
		CurMenuItem=SelMenuItem
		if CurMenuItem<=7{CurBasicLessonMenuItem=CurMenuItem}
		gosub *BasicLessonMenuItem_Focus
	}else{
		redraw 0
		gmode 1
		color
		if CurMenuItem<=7{
			y=CurBasicLessonMenuItem*44+98
			pos 200+MenuItemAniPos.j,y
			gcopy BF_BACKGROUND,200+MenuItemAniPos.j,y,256,40
			if j<MAX_MENU_ANI_CNT{j++}else{j=0}
			gmode 4,,,MenuOpacity
			pos 200+MenuItemAniPos.j,y
			gcopy BF_MENU,256,CurBasicLessonMenuItem*40+BASIC_MENU_POS,256,40
			redraw 1,196,y,264,40
		}else{
			pos 528+MenuItemAniPos.j,368
			gcopy BF_BACKGROUND,528+MenuItemAniPos.j,368,96,96
			if j<MAX_MENU_ANI_CNT{j++}else{j=0}
			gmode 4,,,MenuOpacity
			pos 528+MenuItemAniPos.j,368:gcopy BF_ENDMENU,96,192,96,96
			redraw 1,524,368,104,96
		}
	}

	if BlinkCnt=0{
		rnd n,100
		if n=0{
			gosub *BlinkCharacter
			BlinkCnt=1
		}
	}else{
		BlinkCnt++
		if BlinkCnt=3{
			gosub *DrawCharacter
			BlinkCnt=0
		}
	}
	loop

	if BlinkCnt>0:gosub *DrawCharacter

	redraw 0
	gmode 1
	color
	if CurMenuItem<=7{
		y=CurBasicLessonMenuItem*44+98
		pos 200+MenuItemAniPos.j,y
		gcopy BF_BACKGROUND,200+MenuItemAniPos.j,y,256,40
		gmode 4,,,MenuOpacity
		pos 200,y
		gcopy BF_MENU,512,CurBasicLessonMenuItem*40+BASIC_MENU_POS,256,40
		redraw 1,196,y,264,40
	}else{
		pos 528+MenuItemAniPos.j,368
		gcopy BF_BACKGROUND,528+MenuItemAniPos.j,368,96,96
		gmode 4,,,MenuOpacity
		pos 528,368:gcopy BF_ENDMENU,192,192,96,96
		redraw 1,524,368,104,96
	}

	if Sound & SoundLoaded.SB_MENUSELECTED:snd SB_MENUSELECTED

	repeat 4
	redraw 0
	gmode 1
	repeat 8
	if cnt!=CurMenuItem{
		pos 200,cnt*44+98:gcopy BF_BACKGROUND,200,cnt*44+98,256,40
	}
	loop
	if CurMenuItem!=8{
		pos 528,368:gcopy BF_BACKGROUND,528,368,96,96
	}
	if cnt<=2{
		gmode 4,,,3-cnt*MenuOpacity/4
		repeat 8
		if cnt!=CurMenuItem{
			pos 200,cnt*44+98:gcopy BF_MENU,0,cnt*40+BASIC_MENU_POS,256,40
		}
		loop
		if CurMenuItem!=8{
			pos 528,368:gcopy BF_ENDMENU,0,192,96,96
		}
	}
	redraw 1
	await 50
	loop

	wait 10

	repeat 4
	redraw 0
	gmode 1
	if CurMenuItem<=7{
		pos 200,y:gcopy BF_BACKGROUND,200,y,256,40
	}else{
		pos 528,368:gcopy BF_BACKGROUND,528,368,96,96
	}
	if cnt<=2{
		gmode 4,,,3-cnt*MenuOpacity/4
		if CurMenuItem<=7{
			gcopy BF_MENU,512,CurMenuItem*40+BASIC_MENU_POS,256,40
		}else{
			gcopy BF_ENDMENU,192,192,96,96
		}
	}
	redraw 1
	await 50
	loop

	if CurMenuItem<=7{
		BasicLessonLevel=CurBasicLessonMenuItem
		goto *BasicLesson_Start
	}

	DrawMessage ""

	goto *ReturnMainMenu

*BasicLessonMenuItem_UnFocus
	redraw 0
	gmode 1
	color
	if CurMenuItem<=7{
		y=CurBasicLessonMenuItem*44+98
		pos 200+MenuItemAniPos.j,y
		gcopy BF_BACKGROUND,208+MenuItemAniPos.j,y,256,40
		gmode 4,,,MenuOpacity
		pos 200,y
		gcopy BF_MENU,0,CurBasicLessonMenuItem*40+BASIC_MENU_POS,256,40
		redraw 1,196,y,264,40
	}else{
		pos 528+MenuItemAniPos.j,368
		gcopy BF_BACKGROUND,528+MenuItemAniPos.j,368,96,96
		gmode 4,,,MenuOpacity
		pos 528,368:gcopy BF_ENDMENU,0,192,96,96
		redraw 1,524,368,104,96
	}
	return

*BasicLessonMenuItem_Focus
	redraw 0
	gmode 2
	color
	if CurMenuItem<=7{
		y=CurBasicLessonMenuItem*44+98
		pos 200,y
		gcopy BF_BACKGROUND,200,y,256,40
		gmode 4,,,MenuOpacity
		gcopy BF_MENU,256,CurBasicLessonMenuItem*40+BASIC_MENU_POS,256,40
		redraw 1,200,y,256,40
	}else{
		pos 528,368
		gcopy BF_BACKGROUND,528,368,96,96
		gmode 4,,,MenuOpacity
		gcopy BF_ENDMENU,96,192,96,96
		redraw 1,528,368,96,96
	}
	j=0
	if CurMenuItem=0{
		DrawMessage {"z[|WV̗K܂B
			܂͂ꂩn߂܂傤B"}
	}
	if CurMenuItem=1{
		DrawMessage "lwőłL[̗K܂B"
	}
	if CurMenuItem=2{
		DrawMessage "wőłL[̗K܂B"
	}
	if CurMenuItem=3{
		DrawMessage "wőłL[̗K܂B"
	}
	if CurMenuItem=4{
		DrawMessage "wőłL[̗K܂B"
	}
	if CurMenuItem=5{
		DrawMessage "lwőłA^񒆂̗̃L[̗K܂B"
	}
	if CurMenuItem=6{
		DrawMessage "łK܂B"
	}
	if CurMenuItem=7{
		DrawMessage "L̗K܂B"
	}
	if CurMenuItem=8{
		DrawMessage "Õj[ɂǂ܂B"
	}
	return

*BasicLesson_Start
	ShowKeyboard=TRUE
	gosub *UpKeyboard
	TimeLimit=0
	ShowTimeCnt=FALSE
	ShowWordCnt=FALSE
	Again=FALSE

*BasicLesson_Again
	gosub *InitLesson

	if BasicLessonLevel=0:gosub *BasicLesson_HomePosition
	if BasicLessonLevel=1:gosub *BasicLesson_Fore
	if BasicLessonLevel=2:gosub *BasicLesson_Middle
	if BasicLessonLevel=3:gosub *BasicLesson_Third
	if BasicLessonLevel=4:gosub *BasicLesson_Little
	if BasicLessonLevel=5:gosub *BasicLesson_Fore_Center
	if BasicLessonLevel=6:gosub *BasicLesson_Numerals
	if BasicLessonLevel=7:gosub *BasicLesson_Marks
	if retval=LESSON_BREAK:goto *BasicLesson
	if retval=LESSON_RESTART:goto *BasicLesson_Again

	wait 50

	gosub *FadeKeyboard
	gosub *DrawResult
	if MissTypedCnt>1:gosub *DrawMissTypedKey

	CalcCorrectness n,TypedCharsCnt,MissTypedCnt
	CalcAverage n.1,TypedCharsCnt,TimeCnt
	if n<9500{
		if n.1<14000{
			DrawMessage {"ƃ~XłˁB
				܂͐mɑłĂ悤ɗK܂傤B"}
		}else{
			DrawMessage {"~XłB
				ȂŁAmɑł悤ɂ܂傤B"}
		}
		CurCharImage=CHAR_BAD
	}else{
		if n.1<14000{
			DrawMessage "ƑłĂ悤ɁA΂ėK܂傤B"
		}else{
			if MissTypedCnt{
				DrawMessage {"ȂȂłB
					Ƃ̓~XȂȂ悤ɂ΂܂傤B"}
				CurCharImage=CHAR_GOOD
			}else{
				DrawMessage "fłB\n̒qł΂܂傤B"
				CurCharImage=CHAR_BEST
			}
		}
	}
	if CurCharImage!=CHAR_NORMAL:gosub *DrawCharacter

	gosub *EndLessonMenu
	redraw 0
	gosub *HideResult
	pos 24,80
	gmode 1:gcopy BF_BACKGROUND,24,80,128,128
	gmode 4,,,MenuOpacity/2:color
	gcopy BF_MAINMENU,256,CurMainMenuItem*128,128,128
	gosub *DrawKeyboard
	if CurCharImage!=CHAR_NORMAL{
		CurCharImage=CHAR_NORMAL:gosub *DrawCharacter
	}
	redraw 1
	if retval=1{
		Again=TRUE
		goto *BasicLesson_Again
	}

	DrawMessage ""
	gosub *DownKeyboard

	goto *BasicLesson

*BasicLesson_HomePosition
	DrawMessage "܂́AlŵtƂgłB"
	wait 150
	TypeWords="U\nH\nU\nH\nU\nU\nH\nH\n"
	n.1=-1:i=0
	repeat 16
		repeat
		rnd n,2
		if n=n.1{
			if i=3{continue}
			i++:break
		}else{
			n.1=n
			i=0:break
		}
		loop
	if n:TypeWords+="U\n":else:TypeWords+="H\n"
	loop
	gosub *LessonMain
	if retval:return

	DrawMessage "́AŵdƂsłB"
	wait 150
	TypeWords="E\nT\nE\nT\nE\nE\nT\nT\n"
	n.1=-1:i=0
	repeat 16
		repeat
		rnd n,2
		if n=n.1{
			if i=3{continue}
			i++:break
		}else{
			n.1=n
			i=0:break
		}
		loop
	if n:TypeWords+="E\n":else:TypeWords+="T\n"
	loop
	gosub *LessonMain
	if retval:return

	DrawMessage "́AŵnƂmłB"
	wait 150
	TypeWords="O\nN\nO\nN\nO\nO\nN\nN\n"
	n.1=-1:i=0
	repeat 16
		repeat
		rnd n,2
		if n=n.1{
			if i=3{continue}
			i++:break
		}else{
			n.1=n
			i=0:break
		}
		loop
	if n:TypeWords+="O\n":else:TypeWords+="N\n"
	loop
	gosub *LessonMain
	if retval:return

	DrawMessage "́Aŵ`ƂrłB"
	wait 150
	TypeWords="A\nS\nA\nS\nA\nA\nS\nS\n"
	n.1=-1:i=0
	repeat 16
		repeat
		rnd n,2
		if n=n.1{
			if i=3{continue}
			i++:break
		}else{
			n.1=n
			i=0:break
		}
		loop
	if n:TypeWords+="A\n":else:TypeWords+="S\n"
	loop
	gosub *LessonMain
	if retval:return

	DrawMessage "ł́A\nz[|WV̑S̃L[gĂ݂܂傤B"
	wait 150
	TypeWords="U\nH\nE\nT\nO\nN\nA\nS\nA\nS\nO\nN\nE\nT\nU\nH\n"
	TypeWords+="A\nO\nE\nU\nH\nT\nN\nS\nS\nN\nT\nH\nU\nE\nO\nA\n"
	TypeWords+="A\nH\nO\nT\nE\nN\nU\nS\nU\nS\nE\nN\nO\nT\nA\nH\n"
	gosub *LessonMain
	if retval:return

	DrawMessage {"ŌɁA_ɑłĂ݂܂傤B
		mɑł悤ɂĂˁB"}
	wait 200
	s="A\nO\nE\nU\nH\nT\nN\nS\n"
	repeat 24
	rnd n,8:memcpy TypeWords,s,3,cnt*3,n*3
	loop
	poke TypeWords,24*3,0
	gosub *LessonMain
	return

*BasicLesson_Fore
	DrawMessage "܂́Az[|WV̂tƂgłB"
	wait 150
	TypeWords="U\nH\nU\nH\nU\nH\nU\nH\nU\nU\nH\nH\nU\nU\nH\nH\n"
	gosub *LessonMain
	if retval:return

	DrawMessage "́ÃL[łB"
	wait 150
	TypeWords="U\nP\nU\nK\nU\nP\nU\nK\nP\nK\nP\nK\n"
	gosub *LessonMain
	if retval:return

	DrawMessage "́AẼL[łB"
	wait 150
	TypeWords="H\nG\nH\nM\nH\nG\nH\nM\nG\nM\nG\nM\n"
	gosub *LessonMain
	if retval:return

	DrawMessage "ł́AőłĂ݂܂傤B"
	wait 150
	TypeWords="U\nH\nP\nG\nU\nH\nK\nM\nU\nH\nK\nG\nU\nH\nP\nM\nP\nG\nK\nM\nP\nG\nK\nM\n"
	gosub *LessonMain
	if retval:return

	DrawMessage {"ŌɁA_ɑłĂ݂܂傤B
		mɑł悤ɂĂˁB"}
	wait 200
	s="P\nU\nK\nG\nH\nM\n"
	repeat 24
	rnd n,6:memcpy TypeWords,s,3,cnt*3,n*3
	loop
	poke TypeWords,24*3,0
	gosub *LessonMain

	return

*BasicLesson_Middle
	DrawMessage "܂́Az[|WV̂dƂsłB"
	wait 150
	TypeWords="E\nT\nE\nT\nE\nT\nE\nT\nE\nE\nT\nT\nE\nE\nT\nT\n"
	gosub *LessonMain
	if retval:return

	DrawMessage "́ÃL[łB"
	wait 150
	TypeWords="E\n.\nE\nJ\nE\n.\nE\nJ\n.\nJ\n.\nJ\n"
	gosub *LessonMain
	if retval:return

	DrawMessage "́AẼL[łB"
	wait 150
	TypeWords="T\nC\nT\nW\nT\nC\nT\nW\nC\nW\nC\nW\n"
	gosub *LessonMain
	if retval:return

	DrawMessage "ł́AőłĂ݂܂傤B"
	wait 150
	TypeWords="E\nT\n.\nC\nE\nT\nJ\nW\nE\nT\nJ\nC\nE\nT\n.\nW\n.\nC\nJ\nW\n.\nC\nJ\nW\n"
	gosub *LessonMain
	if retval:return

	DrawMessage {"ŌɁA_ɑłĂ݂܂傤B
		mɑł悤ɂĂˁB"}
	wait 200
	s=".\nE\nJ\nC\nT\nW\n"
	repeat 24
	rnd n,6:memcpy TypeWords,s,3,cnt*3,n*3
	loop
	poke TypeWords,24*3,0
	gosub *LessonMain

	return

*BasicLesson_Third
	DrawMessage "܂́Az[|WV̂nƂmłB"
	wait 150
	TypeWords="O\nN\nO\nN\nO\nN\nO\nN\nO\nO\nN\nN\nO\nO\nN\nN\n"
	gosub *LessonMain
	if retval:return

	DrawMessage "́ÃL[łB"
	wait 150
	TypeWords="O\n,\nO\nQ\nO\n,\nO\nQ\n,\nQ\n,\nQ\n"
	gosub *LessonMain
	if retval:return

	DrawMessage "́AẼL[łB"
	wait 150
	TypeWords="N\nR\nN\nV\nN\nR\nN\nV\nR\nV\nR\nV\n"
	gosub *LessonMain
	if retval:return

	DrawMessage "ł́AőłĂ݂܂傤B"
	wait 150
	TypeWords="O\nN\n,\nR\nO\nN\nQ\nV\nO\nN\nQ\nR\nO\nN\n,\nV\n,\nR\nQ\nV\n,\nR\nQ\nV\n"
	gosub *LessonMain
	if retval:return

	DrawMessage {"ŌɁA_ɑłĂ݂܂傤B
		mɑł悤ɂĂˁB"}
	wait 200
	s=",\nO\nQ\nR\nN\nV\n"
	repeat 24
	rnd n,6:memcpy TypeWords,s,3,cnt*3,n*3
	loop
	poke TypeWords,24*3,0
	gosub *LessonMain

	return

*BasicLesson_Little
	DrawMessage "܂́Az[|WV̂`ƂrłB"
	wait 150
	TypeWords="A\nS\nA\nS\nA\nS\nA\nS\nA\nA\nS\nS\nA\nA\nS\nS\n"
	gosub *LessonMain
	if retval:return

	DrawMessage "́ÃL[łB"
	wait 150
	TypeWords="A\n:\nA\n;\nA\n:\nA\n;\n:\n;\n:\n;\n"
	gosub *LessonMain
	if retval:return

	DrawMessage "́AẼL[łB"
	wait 150
	TypeWords="S\nL\nS\nZ\nS\nL\nS\nZ\nL\nZ\nL\nZ\n"
	gosub *LessonMain
	if retval:return

	DrawMessage "ł́AőłĂ݂܂傤B"
	wait 150
	TypeWords="A\nS\n:\nL\nA\nS\n;\nZ\nA\nS\n;\nL\nA\nS\n:\nZ\n:\nL\n;\nZ\n:\nL\n;\nZ\n"
	gosub *LessonMain
	if retval:return

	DrawMessage {"ŌɁA_ɑłĂ݂܂傤B
		mɑł悤ɂĂˁB"}
	wait 200
	s=":\nA\n;\nL\nS\nZ\n"
	repeat 24
	rnd n,6:memcpy TypeWords,s,3,cnt*3,n*3
	loop
	poke TypeWords,24*3,0
	gosub *LessonMain

	return

*BasicLesson_Fore_Center
	DrawMessage "܂́A^񒆂̍ŝhƂcłB"
	wait 150
	TypeWords="I\nD\nI\nD\nI\nD\nI\nD\nI\nI\nD\nD\nI\nI\nD\nD\n"
	gosub *LessonMain
	if retval:return

	DrawMessage "́ÃL[łB"
	wait 150
	TypeWords="I\nY\nI\nX\nI\nY\nI\nX\nY\nX\nY\nX\n"
	gosub *LessonMain
	if retval:return

	DrawMessage "́AẼL[łB"
	wait 150
	TypeWords="D\nF\nD\nB\nD\nF\nD\nB\nF\nB\nF\nB\n"
	gosub *LessonMain
	if retval:return

	DrawMessage "ł́AőłĂ݂܂傤B"
	wait 150
	TypeWords="I\nD\nY\nF\nI\nD\nX\nB\nI\nD\nX\nF\nI\nD\nY\nB\nX\nB\nY\nF\nX\nB\nY\nF\n"
	gosub *LessonMain
	if retval:return

	DrawMessage {"ŌɁA_ɑłĂ݂܂傤B
		mɑł悤ɂĂˁB"}
	wait 200
	s="Y\nI\nX\nF\nD\nB\n"
	repeat 24
	rnd n,6:memcpy TypeWords,s,3,cnt*3,n*3
	loop
	poke TypeWords,24*3,0
	gosub *LessonMain

	return

*BasicLesson_Numerals
	Drawmessage {"܂́ÃL[łB
		ꕶłz[|WVɖ߂悤ɂĂB"}
	wait 300
	TypeWords="1\nA\n2\nO\n3\nE\n4\nU\n5\nU\n"
	if TypeHand6=TH_LEFT:TypeWords+="6\nU\n5\nU\n"
	TypeWords+="4\nU\n3\nE\n2\nO\n1\nA\n"
	gosub *LessonMain
	if retval:return

	Drawmessage "́AẼL[łB"
	wait 150
	TypeWords=""
	if TypeHand6=TH_RIGHT:TypeWords+="6\nH\n"
	TypeWords+="7\nH\n8\nT\n9\nN\n0\nS\n9\nN\n8\nT\n7\nH\n"
	if TypeHand6=TH_RIGHT:TypeWords+="6\nH\n"
	gosub *LessonMain
	if retval:return

	DrawMessage "ł́AőłĂ݂܂傤B"
	wait 150
	TypeWords="1\nA\n2\nO\n3\nE\n4\nU\n5\nU\n6\n"
	if TypeHand6=TH_RIGHT:TypeWords+="H\n":else:TypeWords+="U\n"
	TypeWords+="7\nH\n8\nT\n9\nN\n0\nS\n"
	gosub *LessonMain
	if retval:return

	DrawMessage {"ŌɁA_ɑłĂ݂܂傤B
		ƃz[|WVɖ߂悤ɂĂˁB"}
	wait 200
	s="1\nA\n2\nO\n3\nE\n4\nU\n5\nU\n7\nH\n8\nT\n9\nN\n0\nS\n"
	if TypeHand6=TH_RIGHT:s+="6\nH\n":else:s+="6\nU\n"
	repeat 24
	rnd n,10:memcpy TypeWords,s,6,cnt*6,n*6
	loop
	poke TypeWords,24*6,0
	wait 200
	gosub *LessonMain

	return

*BasicLesson_Marks
	DrawMessage "܂́Aԏ̗̍̃L[łB"
	wait 150
	TypeWords="!\n\"\n#\n$\n%\n!\n$\n\"\n#\n%\n\"\n$\n!\n#\n%\n"
	gosub *LessonMain
	if retval:return

	DrawMessage "́Aԏ̗̉ẼL[łB"
	wait 150
	TypeWords="'\n(\n)\n'\n&\n'\n(\n)\n(\n'\n&\n'\n)\n(\n&\n'\n"
	gosub *LessonMain
	if retval:return

	DrawMessage "́AȄw̃L[łB"
	wait 150
	TypeWords="-\n/\n-\n^\n@\n^\n-\n[\n-\n^\n]\n^\n-\n[\n/\n-\n^\n]\n@\n^\n\\\n^\n"
	gosub *LessonMain
	if retval:return

	DrawMessage "́AVtgȄw̃L[łB"
	wait 150
	TypeWords="=\n?\n=\n_\n=\n~\n`\n~\n=\n{\n=\n~\n}\n~\n=\n{\n?\n=\n_\n~\n}\n`\n~\n|\n~\n"
	gosub *LessonMain
	if retval:return

	DrawMessage {"ŌɁA_ɑłĂ݂܂傤B
		ςłǁAmɑłĂˁB"}
	wait 200
	s="[\n]\n\\\n/\n@\n-\n^\n{\n}\n|\n?\n`\n=\n~\n_\n!\n\"\n#\n$\n%\n&\n'\n(\n)\n"
	repeat 32
	rnd n,24:memcpy TypeWords,s,3,cnt*3,n*3
	loop
	poke TypeWords,32*3,0
	gosub *LessonMain

	return



*LetterLesson
	ShowKeyboard=TRUE
	gosub *UpKeyboard
	TimeLimit=0
	ShowTimeCnt=FALSE
	ShowWordCnt=TRUE
	WordCntType=WCTYPE_LETTER
	TypeWordsAll=50
	Again=FALSE

*LetterLesson_Again
	DrawMessage "΂ĂˁB"

	wait 30

	gosub *InitLesson

	TypeWords=""
	poke s,1,0
	repeat 30
	rnd n,26:poke s,0,'A'+n
	TypeWords+=s+"\n"
	loop

	gosub *LessonMain
	if retval=LESSON_BREAK:goto *ReturnMainMenu
	if retval=LESSON_RESTART:goto *LetterLesson_Again

	if TypedCharsCnt/10<=MissTypedCnt{
		if TypedCharsCnt*6000/TimeCnt<100{
			DrawMessage "Ɛmɑł܂傤B"
		}else{
			DrawMessage "ĊmɑłĂ"
		}
	}else{
		if TypedCharsCnt*6000/TimeCnt<100{
			DrawMessage "ǂǂ񒲎qグĂ܂傤B"
		}else{
			DrawMessage "ЂƂ΂łB"
		}
	}

	i=0,0
	if MissTypedCnt>0{
		repeat 95
		if MissTypedKey.cnt>0{
			i++
			i.1+=MissTypedKey.cnt
		}
		loop
		if i>5{i=5}
	}

	TypeWords=""
	poke s,1,0
	repeat 20-i
	rnd n,36
	if n<=25:poke s,0,'A'+n:else:poke s,0,'0'+n-26
	TypeWords+=s+"\n"
	loop

	if i>0{
		dim tmp,i.1
		j=0:n=0
		repeat 95
			repeat MissTypedKey.j
			tmp.n=j
			n++
			loop
		j++
		loop
		repeat i
		rnd n,i.1:poke s,0,tmp.n+32
		TypeWords+=s+"\n"
		loop
	}

	gosub *LessonMain
	if retval=LESSON_BREAK:goto *ReturnMainMenu
	if retval=LESSON_RESTART:goto *LetterLesson_Again

	wait 50

	gosub *FadeKeyboard
	gosub *DrawResult
	if MissTypedCnt>1:gosub *DrawMissTypedKey

	if TypedCharsCnt+MissTypedCnt>0{
		CalcCorrectness n,TypedCharsCnt,MissTypedCnt
	}else{
		n=0
	}
	CalcAverage n.1,TypedCharsCnt,TimeCnt
	if n<9300{
		if n.1<12000{
			DrawMessage "~XłB\nƐmɑł悤ɂ܂傤B"
		}else{
			DrawMessage "܂́Ał萳mɑł悤ɐS|܂傤B"
		}
		CurCharImage=CHAR_BAD
	}else{
		if n.1<12000{
			DrawMessage "ƑłĂ悤ɁAǂǂK܂傤B"
		}else{
			if MissTypedCnt>=2{
				DrawMessage {"ȂȂłB
					̓~XOɂȂ悤ɂ΂܂傤B"}
				CurCharImage=CHAR_GOOD
			}else{
				DrawMessage "łB\n̒qł΂܂傤B"
				CurCharImage=CHAR_BEST
			}
		}
	}
	if CurCharImage!=CHAR_NORMAL:gosub *DrawCharacter

	if LetterLessonHistoryCnt<MAX_HISTORY{
		i=LetterLessonHistoryCnt
		LetterLessonHistoryCnt++
	}else{
		repeat MAX_HISTORY-1
		i=cnt+1
		LetterLessonHistory_Speed.cnt=LetterLessonHistory_Speed.i
		LetterLessonHistory_Correctness.cnt=LetterLessonHistory_Correctness.i
		loop
		i=MAX_HISTORY-1
	}
	LetterLessonHistory_Speed.i=n.1
	LetterLessonHistory_Correctness.i=n

	gosub *KeyInWait

	if LetterLessonHistoryCnt>=2{
		s=""
		if LetterLessonHistoryCnt>=10{
			i=LetterLessonHistoryCnt-10:j=i+1
			n=0
			repeat 9
			n+=LetterLessonHistory_Speed.j-LetterLessonHistory_Speed.i
			i++:j++
			loop
			n=n/9
			if n>=100{s="ǂǂ񑬂Ă܂傤ˁB"}
			if n>=150{s="ȂȂłB"}
			if n<=-100{s="[AƍŋߗǂȂłˁB"}
		}
		DrawMessage "܂őł̋L^łB\n"+s
	}else{
		DrawMessage {"ł̋L^\܂B
			Ȃ悤ɂ΂ėKĂˁB"}
	}
	if CurCharImage!=CHAR_NORMAL{
		CurCharImage=CHAR_NORMAL:gosub *DrawCharacter
	}

	redraw 0
	gosub *HideWordCnt
	gosub *HideResult
	pos 24,80
	gmode 1:gcopy BF_BACKGROUND,24,80,128,128
	gmode 4,,,MenuOpacity/2:color
	gcopy BF_MAINMENU,256,CurMainMenuItem*128,128,128
	color 255,255,255:FadeImage 128,24,80,480,192
	color 192,192,192
	repeat 4
	line 504,271-(cnt*48),104,271-(cnt*48)
	loop
	repeat MAX_HISTORY/10
	x=400/MAX_HISTORY*cnt*10+104
	line x,271,x,80
	loop
	gmode 2
	pos 56,252:gcopy BF_MESSAGES,260,248,40,16
	repeat 3
	pos 56,216-(cnt*48):gcopy BF_MESSAGES,260,cnt*16+200,40,16
	loop
	redraw 1
	pos 104,272-(192*LetterLessonHistory_Correctness.0/10000)
	repeat LetterLessonHistoryCnt
	if cnt!=(LetterLessonHistoryCnt-1){
		color 128,128,128
	}else{
		color 0,160,255
	}
	x=400/MAX_HISTORY*cnt+104
	y=271-(192*LetterLessonHistory_Speed.cnt/40000)
	boxf x,y,x+(400/MAX_HISTORY-2),271
	color 255,0,0
	y=272-(192*LetterLessonHistory_Correctness.cnt/10000)
	if cnt>0:line x,y
	if cnt=(LetterLessonHistoryCnt-1):pset x,y
	await 20
	loop

	gosub *EndLessonMenu
	redraw 0
	gmode 1
	pos 24,80:gcopy BF_BACKGROUND,24,80,480,192
	gmode 4,,,MenuOpacity/2:color
	pos 24,80:gcopy BF_MAINMENU,256,CurMainMenuItem*128,128,128
	redraw 1
	gosub *DrawKeyboard
	if retval=1{
		Again=TRUE
		goto *LetterLesson_Again
	}

	DrawMessage ""
	gosub *DownKeyboard

	goto *ReturnMainMenu



*WordLesson
	ShowKeyboard=TRUE
	gosub *UpKeyboard
	TimeLimit=0
	ShowTimeCnt=FALSE
	ShowWordCnt=TRUE
	WordCntType=WCTYPE_WORD
	TypeWordsAll=30
	Again=FALSE

*WordLesson_Again
	DrawMessage "΂ĂˁB"

	wait 30

	gosub *InitLesson

	notesel WordsDic
	TypeWords=""
	n.1=-1
	repeat 10
		repeat
		rnd n,DicWordsNum/5+(DicWordsNum\5)
		if n!=n.1:break
		loop
	noteget s,n:TypeWords+=s+"\n"
	n.1=n
	loop

	gosub *LessonMain
	if retval=LESSON_BREAK:goto *ReturnMainMenu
	if retval=LESSON_RESTART:goto *WordLesson_Again

	if TypedCharsCnt/10<=MissTypedCnt{
		if TypedCharsCnt*6000/TimeCnt<160{
			DrawMessage "đł܂傤B"
		}else{
			DrawMessage "mɑłčs܂傤B"
		}
	}else{
		if TypedCharsCnt*6000/TimeCnt<160{
			DrawMessage "ƑłĂƂłB"
		}else{
			DrawMessage "łA̒qłB"
		}
	}

	notesel WordsDic
	TypeWords=""
	n.1=-1
	repeat 10
		repeat
		rnd n,DicWordsNum/5+(DicWordsNum\5)
		if n!=n.1:break
		loop
	noteget s,DicWordsNum/5+n:TypeWords+=s+"\n"
	n.1=n
	loop

	gosub *LessonMain
	if retval=LESSON_BREAK:goto *ReturnMainMenu
	if retval=LESSON_RESTART:goto *WordLesson_Again

	if TypedCharsCnt/10<=MissTypedCnt{
		if TypedCharsCnt*6000/TimeCnt<180{
			DrawMessage "ƐmɑłĂB"
		}else{
			DrawMessage "ȂŐmɑł܂傤B"
		}
	}else{
		if TypedCharsCnt*6000/TimeCnt<180{
			DrawMessage "y[Xグ܂傤B"
		}else{
			DrawMessage "AЂƂ΂łB"
		}
	}

	notesel WordsDic
	TypeWords=""
	n.1=-1
	repeat 10
		repeat
		rnd n,DicWordsNum/5+(DicWordsNum\5)
		if n!=n.1:break
		loop
	noteget s,DicWordsNum/5*2+n:TypeWords+=s+"\n"
	n.1=n
	loop

	gosub *LessonMain
	if retval=LESSON_BREAK:goto *ReturnMainMenu
	if retval=LESSON_RESTART:goto *WordLesson_Again

	wait 50

	gosub *FadeKeyboard
	gosub *DrawResult
	if MissTypedCnt>1:gosub *DrawMissTypedKey

	if TypedCharsCnt+MissTypedCnt>0{
		CalcCorrectness n,TypedCharsCnt,MissTypedCnt
	}else{
		n=0
	}
	CalcAverage n.1,TypedCharsCnt,TimeCnt
	if n<9500{
		if n.1<18000{
			DrawMessage {"~XłB
				܂͐mɑłĂ悤ɗK܂傤B"}
		}else{
			DrawMessage "Đmɑł悤ɂ܂傤B"
		}
		CurCharImage=CHAR_BAD
	}else{
		if n.1<18000{
			DrawMessage "ƑłĂ悤ɂ΂܂傤B"
		}else{
			if MissTypedCnt>=2{
				DrawMessage {"ȂȂłB
					Ƃ̓~XȂ悤ɂ܂傤B"}
			}else{
				DrawMessage "łB\n̒qł΂܂傤B"
			}
			CurCharImage=CHAR_GOOD
		}
	}
	if CurCharImage!=CHAR_NORMAL:gosub *DrawCharacter

	if (WordLessonHistoryCnt<MAX_HISTORY){
		i=WordLessonHistoryCnt
		WordLessonHistoryCnt++
	}else{
		repeat MAX_HISTORY-1
		i=cnt+1
		WordLessonHistory_Speed.cnt=WordLessonHistory_Speed.i
		WordLessonHistory_Correctness.cnt=WordLessonHistory_Correctness.i
		loop
		i=MAX_HISTORY-1
	}
	WordLessonHistory_Speed.i=n.1
	WordLessonHistory_Correctness.i=n

	gosub *KeyInWait

	if WordLessonHistoryCnt>=2{
		s=""
		if WordLessonHistoryCnt>=10{
			i=WordLessonHistoryCnt-10:j=i+1
			n=0
			repeat 9
			n+=WordLessonHistory_Speed.j-WordLessonHistory_Speed.i
			i++:j++
			loop
			n=n/9
			if n>=150{s="ǂǂ񑬂Ă܂傤ˁB"}
			if n>=200{s="ȂȂłˁB"}
			if n<=-150{s="[Aǂ܂H"}
		}
		DrawMessage "܂őł̋L^łB\n"+s
	}else{
		DrawMessage {"ł̋L^\܂B
			Ȃ悤ɂǂǂKĂˁB"}
	}
	if CurCharImage!=CHAR_NORMAL{
		CurCharImage=CHAR_NORMAL:gosub *DrawCharacter
	}

	redraw 0
	gosub *HideWordCnt
	gosub *HideResult
	pos 24,80
	gmode 1:gcopy BF_BACKGROUND,24,80,128,128
	gmode 4,,,MenuOpacity/2:color
	gcopy BF_MAINMENU,256,CurMainMenuItem*128,128,128
	color 255,255,255:FadeImage 192,24,80,480,192
	color 192,192,192
	repeat 4
	line 504,271-(cnt*48),104,271-(cnt*48)
	loop
	repeat MAX_HISTORY/10
	x=400/MAX_HISTORY*cnt*10+104
	line x,271,x,80
	loop
	gmode 2
	pos 56,252:gcopy BF_MESSAGES,260,248,40,16
	repeat 3
	pos 56,216-(cnt*48):gcopy BF_MESSAGES,260,cnt*16+200,40,16
	loop
	redraw 1
	pos 104,272-(192*WordLessonHistory_Correctness.0/10000)
	repeat WordLessonHistoryCnt
	if cnt!=(WordLessonHistoryCnt-1){
		color 128,128,128
	}else{
		color 0,160,255
	}
	x=400/MAX_HISTORY*cnt+104
	y=271-(192*WordLessonHistory_Speed.cnt/40000)
	boxf x,y,x+(400/MAX_HISTORY-2),271
	color 255,0,0
	y=272-(192*WordLessonHistory_Correctness.cnt/10000)
	if cnt>0:line x,y
	if cnt=(WordLessonHistoryCnt-1):pset x,y
	await 20
	loop

	gosub *EndLessonMenu
	redraw 0
	gmode 1
	pos 24,80:gcopy BF_BACKGROUND,24,80,480,192
	gmode 4,,,MenuOpacity/2:color
	pos 24,80:gcopy BF_MAINMENU,256,CurMainMenuItem*128,128,128
	redraw 1
	gosub *DrawKeyboard
	if retval=1{
		Again=TRUE
		goto *WordLesson_Again
	}

	DrawMessage ""
	gosub *DownKeyboard

	goto *ReturnMainMenu



*TimeTrial
	color
	x=0,0
	x.3=0
	n=16
	repeat n
	redraw 0
	if cnt{
		gmode 1
		pos x,142:gcopy BF_BACKGROUND,x,142,x.1,260
		pos x.2,368:gcopy BF_BACKGROUND,x.2,368,x.3,96
	}
	pos 24,80
	gcopy BF_BACKGROUND,24,80,128,128
	gmode 4,,,MenuOpacity/2
	gcopy BF_MAINMENU,256,CurMainMenuItem*128,128,128
	gmode 4,,,MenuOpacity*(cnt+1)/n
	if x.1<256{
		x.1=456*(cnt+1)/n:if x.1>256{x=x.1-256:x.1=256}
	}else{
		x=456*(cnt+1)/n-256
	}
		repeat 6
		pos x,cnt*44+142
		gcopy BF_MENU,256-x.1,cnt*40+TRIAL_MENU_POS,x.1,40
		loop
	x.2=640-(112*(cnt+1)/n)
	if x.3<96{
		x.3=640-x.2:if x.3>96{x.3=96}
	}
	pos x.2,368:gcopy BF_ENDMENU,0,192,x.3,96
	redraw 1
	await 50
	loop

	CurMenuItem=CurTimeTrialMenuItem
	gosub *TimeTrialMenuItem_Focus

	CurKey=0
	mx=-1:my=-1
	BlinkCnt=0

	repeat
	await 50

	stick n,0x040A,1
	if n&0x130:break	;Space or Enter or LButton
	if n&0x80{			;Esc
		gosub *TimeTrialMenuItem_UnFocus
		CurMenuItem=6
		break
	}
	SelMenuItem=CurMenuItem
	if n&0x0A=0x02{	;Up and !Down
		if CurKey&0x02{KeyRepeatCnt++}else{CurKey=CurKey|0x02:KeyRepeatCnt=0}
		if KeyRepeatCnt\3=0{
			if (SelMenuItem>=1) & (SelMenuItem<=5){
				SelMenuItem--
			}
		}
	}else{
		if CurKey&0x02{CurKey=CurKey^0x02}
	}
	if n&0x0A=0x08{	;Down and !Up
		if CurKey&0x08{KeyRepeatCnt++}else{CurKey=CurKey|0x08:KeyRepeatCnt=0}
		if KeyRepeatCnt\3=0{
			if SelMenuItem<=4{
				SelMenuItem++
			}
		}
	}else{
		if CurKey&0x08{CurKey=CurKey^0x08}
	}
	if n&0x05=0x01{	;Left and !Right
		CurKey=CurKey|0x01
		if SelMenuItem=6{
			SelMenuItem=CurTimeTrialMenuItem
		}
	}else{
		if CurKey&0x01{CurKey=CurKey^0x01}
	}
	if n&0x05=0x04{	;Right and !Left
		CurKey=CurKey|0x04
		if SelMenuItem<=5{
			SelMenuItem=6
		}
	}else{
		if CurKey&0x04{CurKey=CurKey^0x04}
	}
	if n=0x400{		;Tab
		if CurKey&0x400{KeyRepeatCnt++}else{CurKey=CurKey|0x400:KeyRepeatCnt=0}
		if KeyRepeatCnt\3=0{
			SelMenuItem=SelMenuItem+1\7
		}
	}else{
		if CurKey&0x400{CurKey=CurKey^0x400}
	}

	if (mousex!=mx) | (mousey!=my){
		i=-1
		repeat 6
		y=cnt*44+142
		if (mousex>=200) & (mousex<456) & (mousey>=y) & (mousey<(y+40)){
			i=cnt:break
		}
		loop
		if i<0{
			if (mousex>=528) & (mousex<624) & (mousey>=368) & (mousey<464){
				i=6
			}
		}
		if (i>=0) & (i!=SelMenuItem){
			SelMenuItem=i
		}
		mx=mousex:my=mousey
	}

	if SelMenuItem!=CurMenuItem{
		gosub *TimeTrialMenuItem_UnFocus
		CurMenuItem=SelMenuItem
		if CurMenuItem<=5{CurTimeTrialMenuItem=CurMenuItem}
		gosub *TimeTrialMenuItem_Focus
	}else{
		redraw 0
		gmode 1
		color
		if CurMenuItem<=5{
			y=CurTimeTrialMenuItem*44+142
			pos 200+MenuItemAniPos.j,y
			gcopy BF_BACKGROUND,200+MenuItemAniPos.j,y,256,40
			if j<MAX_MENU_ANI_CNT{j++}else{j=0}
			gmode 4,,,MenuOpacity
			pos 200+MenuItemAniPos.j,y
			gcopy BF_MENU,256,CurTimeTrialMenuItem*40+TRIAL_MENU_POS,256,40
			redraw 1,196,y,264,40
		}else{
			pos 528+MenuItemAniPos.j,368
			gcopy BF_BACKGROUND,528+MenuItemAniPos.j,368,96,96
			if j<MAX_MENU_ANI_CNT{j++}else{j=0}
			gmode 4,,,MenuOpacity
			pos 528+MenuItemAniPos.j,368:gcopy BF_ENDMENU,96,192,96,96
			redraw 1,524,368,104,96
		}
	}

	if BlinkCnt=0{
		rnd n,100
		if n=0{
			gosub *BlinkCharacter
			BlinkCnt=1
		}
	}else{
		BlinkCnt++
		if BlinkCnt=3{
			gosub *DrawCharacter
			BlinkCnt=0
		}
	}
	loop

	if BlinkCnt>0:gosub *DrawCharacter

	redraw 0
	gmode 1
	color
	if CurMenuItem<=5{
		y=CurTimeTrialMenuItem*44+142
		pos 200+MenuItemAniPos.j,y
		gcopy BF_BACKGROUND,200+MenuItemAniPos.j,y,256,40
		gmode 4,,,MenuOpacity
		pos 200,y
		gcopy BF_MENU,512,CurTimeTrialMenuItem*40+TRIAL_MENU_POS,256,40
		redraw 1,196,y,264,40
	}else{
		pos 528+MenuItemAniPos.j,368
		gcopy BF_BACKGROUND,512+MenuItemAniPos.j,368,96,96
		gmode 4,,,MenuOpacity
		pos 528,368:gcopy BF_ENDMENU,192,192,96,96
		redraw 1,524,368,104,96
	}

	if Sound & SoundLoaded.SB_MENUSELECTED:snd SB_MENUSELECTED

	repeat 4
	redraw 0
	gmode 1
	repeat 6
	if cnt!=CurMenuItem{
		pos 200,cnt*44+142:gcopy BF_BACKGROUND,200,cnt*44+142,256,40
	}
	loop
	if CurMenuItem!=6{
		pos 528,368:gcopy BF_BACKGROUND,528,368,96,96
	}
	if cnt<=2{
		gmode 4,,,3-cnt*MenuOpacity/4
		repeat 6
		if cnt!=CurMenuItem{
			pos 200,cnt*44+142:gcopy BF_MENU,0,cnt*40+TRIAL_MENU_POS,256,40
		}
		loop
		if CurMenuItem!=6{
			pos 528,368:gcopy BF_ENDMENU,0,192,96,96
		}
	}
	redraw 1
	await 50
	loop

	wait 10

	repeat 4
	redraw 0
	gmode 1
	if CurMenuItem<=5{
		pos 200,y:gcopy BF_BACKGROUND,200,y,256,40
	}else{
		pos 528,368:gcopy BF_BACKGROUND,528,368,96,96
	}
	if cnt<=2{
		gmode 4,,,3-cnt*MenuOpacity/4
		if CurMenuItem<=5{
			gcopy BF_MENU,512,CurMenuItem*40+TRIAL_MENU_POS,256,40
		}else{
			gcopy BF_ENDMENU,192,192,96,96
		}
	}
	redraw 1
	await 50
	loop

	if CurMenuItem<=5{
		TimeTrialLevel=CurTimeTrialMenuItem
		goto *TimeTrial_Start
	}

	DrawMessage ""

	goto *ReturnMainMenu

*TimeTrialMenuItem_UnFocus
	redraw 0
	gmode 1
	color
	if CurMenuItem<=5{
		y=CurTimeTrialMenuItem*44+142
		pos 200+MenuItemAniPos.j,y
		gcopy BF_BACKGROUND,200+MenuItemAniPos.j,y,256,40
		gmode 4,,,MenuOpacity
		pos 200,y
		gcopy BF_MENU,0,CurTimeTrialMenuItem*40+TRIAL_MENU_POS,256,40
		redraw 1,196,y,264,40
	}else{
		pos 528+MenuItemAniPos.j,368
		gcopy BF_BACKGROUND,528+MenuItemAniPos.j,368,96,96
		gmode 4,,,MenuOpacity
		pos 528,368:gcopy BF_ENDMENU,0,192,96,96
		redraw 1,524,368,104,96
	}
	return

*TimeTrialMenuItem_Focus
	redraw 0
	gmode 2
	color
	if CurMenuItem<=5{
		y=CurTimeTrialMenuItem*44+142
		pos 200,y
		gcopy BF_BACKGROUND,200,y,256,40
		gmode 4,,,MenuOpacity
		gcopy BF_MENU,256,CurTimeTrialMenuItem*40+TRIAL_MENU_POS,256,40
		redraw 1,200,y,256,40
	}else{
		pos 528,368
		gcopy BF_BACKGROUND,528,368,96,96
		gmode 4,,,MenuOpacity
		gcopy BF_ENDMENU,96,192,96,96
		redraw 1,528,368,96,96
	}
	j=0
	if CurMenuItem=0{
		DrawMessage "30bԂłł邾̕ł܂B"
	}
	if CurMenuItem=1{
		DrawMessage "1Ԃłł邾̕ł܂B"
	}
	if CurMenuItem=2{
		DrawMessage "2Ԃłł邾̕ł܂B"
	}
	if CurMenuItem=3{
		DrawMessage "3Ԃłł邾̕ł܂B"
	}
	if CurMenuItem=4{
		DrawMessage "5Ԃłł邾̕ł܂B"
	}
	if CurMenuItem=5{
		DrawMessage "10Ԃłł邾̕ł܂B"
	}
	if CurMenuItem=6{
		DrawMessage "Õj[ɂǂ܂B"
	}
	return

*TimeTrial_Start
	if TimeTrialLevel=0:TimeLimit=3000
	if TimeTrialLevel=1:TimeLimit=6000
	if TimeTrialLevel=2:TimeLimit=12000
	if TimeTrialLevel=3:TimeLimit=18000
	if TimeTrialLevel=4:TimeLimit=30000
	if TimeTrialLevel=5:TimeLimit=60000
	ShowTimeCnt=TRUE
	ShowWordCnt=FALSE
	ShowKeyboard=FALSE
	Again=FALSE

*TimeTrial_Again
	DrawMessage "΂ĂˁB"

	wait 30

	gosub *InitLesson

*TimeTrial_SetTypeWords
	TypeWords=""
	i=TypedWordsCnt
	n.1=-1
	notesel WordsDic
	repeat 50
		repeat
		rnd n,DicWordsNum/4+(DicWordsNum\4)
		if i<30{
			n+=i/10+1*(DicWordsNum/4)
		}else{
			n+=DicWordsNum/4*3
		}
		if n!=n.1:break
		loop

	;For Debug
	if n>=DicWordsNum:dialog "*TimeTrial Make TypeWords",1,"Error":goto *Exit

	noteget s,n:TypeWords+=s+"\n"
	n.1=n
	i++
	loop

	gosub *LessonMain
	if retval=LESSON_BREAK:goto *TimeTrial
	if retval=LESSON_RESTART:goto *TimeTrial_Again
	if TimeCnt<TimeLimit:goto *TimeTrial_SetTypeWords

	gmode 4,,,128
	pos WordPos.Left,WordPos.Top
	gcopy BF_BACKGROUND,WordPos.Left,WordPos.Top,FONT_WIDTH*CurWordLen,FONT_HEIGHT

	if Sound & SoundLoaded.SB_TIMEUP:snd SB_TIMEUP
	wait 50

	gosub *DrawResult

	if TypedCharsCnt+MissTypedCnt>0{
		CalcCorrectness n,TypedCharsCnt,MissTypedCnt
	}else{
		n=0
	}
	CalcAverage n.1,TypedCharsCnt,TimeCnt
	if n<9500{
		DrawMessage "~XłB\n܂͂ƃL[zo܂傤B"
		CurCharImage=CHAR_BAD
	}else{
		if n.1<(20000-(TimeLimit/30)){
			DrawMessage "͂ƑłĂ悤ɂ΂܂傤B"
		}else{
			if n.1<(23000-(TimeLimit/30)){
				DrawMessage {"łB
					̒qłƑȂ悤ɂ΂܂傤B"}
			}else{
				if n.1<(26000-(TimeLimit/30)){
					if MissTypedCnt{
						DrawMessage {"̓ob`łB
							̓~XȂȂ悤ɂ΂Ă݂܂傤B"}
						CurCharImage=CHAR_GOOD
					}else{
						DrawMessage {"ob`łB
							ɖ܂傤B"}
						CurCharImage=CHAR_BEST
					}
				}else{
					DrawMessage "łB\nƂ܂B"
					CurCharImage=CHAR_BEST
				}
			}
		}
	}
	if CurCharImage!=CHAR_NORMAL:gosub *DrawCharacter

	gosub *KeyInWait

	redraw 0
	gosub *HideCurWord
	gosub *HideTimeCnt
	gosub *HideResult
	pos 24,80
	gmode 1:gcopy BF_BACKGROUND,24,80,128,128
	gmode 4,,,MenuOpacity/2:color
	gcopy BF_MAINMENU,256,CurMainMenuItem*128,128,128
	redraw 1

	CalcAverage Score,TypedCharsCnt,TimeCnt
	i=9
	repeat 10
	if Score<=TimeTrialRanking_Score.TimeTrialLevel.i:break
	i--
	loop
	if i<9{
		CurRank=i+1
		n=0
		repeat 10
		if TimeTrialRanking_Score.TimeTrialLevel.cnt=0{break}
		n++
		loop
		if ((n=10) & (CurRank<9)) | ((n<10) & (CurRank<n)){
			i=9:j=8
			repeat 9-CurRank
			TimeTrialRanking_Score.TimeTrialLevel.i=TimeTrialRanking_Score.TimeTrialLevel.j
			TimeTrialRanking_Correctness.TimeTrialLevel.i=TimeTrialRanking_Correctness.TimeTrialLevel.j
			TimeTrialRanking_Date.TimeTrialLevel.i=TimeTrialRanking_Date.TimeTrialLevel.j
			i--:j--
			loop
		}
		TimeTrialRanking_Score.TimeTrialLevel.CurRank=Score
;		TimeTrialRanking_Correctness.TimeTrialLevel.CurRank=TypedCharsCnt*10000/(TypedCharsCnt+MissTypedCnt)
		if TypedCharsCnt+MissTypedCnt>0{
			CalcCorrectness TimeTrialRanking_Correctness.TimeTrialLevel.CurRank,TypedCharsCnt,MissTypedCnt
		}else{
			TimeTrialRanking_Correctness.TimeTrialLevel.CurRank=0
		}
		gettime n.1,0:gettime n.2,1:gettime n.3,3
		TimeTrialRanking_Date.TimeTrialLevel.CurRank=(n.1<<16)|(n.2<<8)|(n.3)

		if n=0{
			DrawMessage "POʂ܂ł̃LO\܂B"
			CurCharImage=CHAR_NORMAL
		}else{
			if (n=10) & (CurRank=0){
				DrawMessage "܂I\n܂ł̍ōL^łB"
				CurCharImage=CHAR_BEST
			}else{
				i=CurRank+1
				if CurRank<(n/2){
					DrawMessage {"߂łƂ܂B
						"}+i+"ʂɃNC܂B"
					CurCharImage=CHAR_BEST
				}else{
					DrawMessage {"LOłB
						"}+i+"ʂɃNC܂B"
					if n=10{
						CurCharImage=CHAR_GOOD
					}else{
						CurCharImage=CHAR_NORMAL
					}
				}
			}
		}
	}else{
		CurRank=-1
		DrawMessage {"LOłB
			NCł悤ɂ΂܂傤B"}
		CurCharImage=CHAR_NORMAL
	}
	gosub *DrawCharacter

	buffer BF_TEMP,480,312,COLORMODE
	color:boxf 0,0,479,311
	gmode 0
	y=0
	repeat 10
	if TimeTrialRanking_Score.TimeTrialLevel.cnt=0:break
	if cnt=CurRank:i=1:else:i=0
	x=0
	if cnt>=9{
		pos x,y:gcopy BF_MESSAGES,cnt+1/10*20,i*24+200,20,24
	}
	pos x+20,y:gcopy BF_MESSAGES,cnt+1\10*20,i*24+200,20,24

	n=TimeTrialRanking_Score.TimeTrialLevel.cnt
	x+=50:x.1=90
		repeat
		pos x+x.1,y:gcopy BF_MESSAGES,n\10*20,i*24+200,20,24
		if cnt=1{
			x.1-=10
			pos x+x.1,y:gcopy BF_MESSAGES,200,i*24+200,10,24
		}
		n=n/10:if (n=0) & (cnt>=2):break
		x.1-=20
		loop
	pos x+110,y:gcopy BF_MESSAGES,220,i*24+200,20,24

	n=TimeTrialRanking_Correctness.TimeTrialLevel.cnt
	x+=140:x.1=90
		repeat
		pos x+x.1,y:gcopy BF_MESSAGES,n\10*20,i*24+200,20,24
		if cnt=1{
			x.1-=10
			pos x+x.1,y:gcopy BF_MESSAGES,200,i*24+200,10,24
		}
		n=n/10:if (n=0) & (cnt>=2):break
		x.1-=20
		loop
	pos x+110,y:gcopy BF_MESSAGES,240,i*24+200,20,24

	n=TimeTrialRanking_Date.TimeTrialLevel.cnt>>16
	x+=140
	pos x,y:gcopy BF_MESSAGES,n/10\10*20,i*24+200,20,24
	pos x+20,y:gcopy BF_MESSAGES,n\10*20,i*24+200,20,24
	pos x+40,y:gcopy BF_MESSAGES,210,i*24+200,10,24
	n=TimeTrialRanking_Date.TimeTrialLevel.cnt>>8&0xFF
	x+=50
	pos x,y:gcopy BF_MESSAGES,n/10*20,i*24+200,20,24
	pos x+20,y:gcopy BF_MESSAGES,n\10*20,i*24+200,20,24
	pos x+40,y:gcopy BF_MESSAGES,210,i*24+200,10,24
	n=TimeTrialRanking_Date.TimeTrialLevel.cnt&0xFF
	x+=50
	pos x,y:gcopy BF_MESSAGES,n/10*20,i*24+200,20,24
	pos x+20,y:gcopy BF_MESSAGES,n\10*20,i*24+200,20,24

	y+=32
	loop

	gsel MainWindowID
	color
	n=20
	y.1=0
	repeat n
	redraw 0
	if cnt{
		gmode 1
		gcopy BF_BACKGROUND,24,y,480,y.1
		pos 24,80
		gcopy BF_BACKGROUND,24,80,128,128
		gmode 4,,,MenuOpacity/2
		gcopy BF_MAINMENU,256,CurMainMenuItem*128,128,128
	}
	y=480-(364*(cnt+1)/n)
	if y.1<312{
		y.1=480-y:if y.1>312{y.1=312}
	}
	gmode 2
	pos 24,y:gcopy BF_TEMP,0,0,480,y.1
	redraw 1,24,y,480,480-y
	await 50
	loop

	gosub *EndLessonMenu
	redraw 0
	pos 24,80
	gmode 1:gcopy BF_BACKGROUND,24,80,480,348
	gmode 4,,,MenuOpacity/2:color
	gcopy BF_MAINMENU,256,CurMainMenuItem*128,128,128
	if CurCharImage!=CHAR_NORMAL{
		CurCharImage=CHAR_NORMAL:gosub *DrawCharacter
	}
	redraw 1
	if retval=1{
		Again=TRUE
		goto *TimeTrial_Again
	}

	DrawMessage ""

	goto *TimeTrial



*KeyInWait
	BlinkCnt=0

	repeat
	stick n,0xBF,1
	if n&0x130:break	;Space or Enter or LButton

	wait 5

	if BlinkCnt=0{
		rnd n,100
		if n=0{
			gosub *BlinkCharacter
			BlinkCnt=1
		}
	}else{
		BlinkCnt++
		if BlinkCnt=3{
			gosub *DrawCharacter
			BlinkCnt=0
		}
	}
	loop

	if BlinkCnt>0:gosub *DrawCharacter
	return



*EndLessonMenu
	if Again:CurMenuItem=1:else:CurMenuItem=0

	color
	n=8
	x.1=0
	if CurMenuItem=0{
		x.2=96:x.3=0
	}else{
		x.2=0:x.3=96
	}
	repeat n
	redraw 0
	if cnt{
		gmode 1
		pos x,256:gcopy BF_BACKGROUND,x,256,x.1,208
	}
	x=640-(112*(cnt+1)/n)
	if x.1<96{
		x.1=640-x:if x.1>96{x.1=96}
	}
	gmode 4,,,MenuOpacity*(cnt+1)/n
	pos x,256:gcopy BF_ENDMENU,x.2,0,x.1,96
	pos x,368:gcopy BF_ENDMENU,x.3,96,x.1,96
	redraw 1,x,256,640-x,208
	await 50
	loop

	gosub *EndLessonMenuItem_Focus

	mx=-1:my=-1
	BlinkCnt=0

	repeat
	await 50

	stick n,0,1
	if n&0x130:break	;Space or Enter or LButton
	SelMenuItem=CurMenuItem
	if (n&0x0A=0x02) & (SelMenuItem>=1){	;Up and !Down
		SelMenuItem--
	}
	if (n&0x0A=0x08) & (SelMenuItem<=0){	;Down and !Up
		SelMenuItem++
	}
	if n=0x400{	;Tab
		SelMenuItem=SelMenuItem+1\2
	}

	if (mousex!=mx) | (mousey!=my){
		i=-1
		repeat 2
		y=cnt*112+256
		if (mousex>=528) & (mousex<624) & (mousey>=y) & (mousey<(y+96)){
			i=cnt:break
		}
		loop
		if (i>=0) & (i!=SelMenuItem){
			SelMenuItem=i
		}
		mx=mousex:my=mousey
	}

	if SelMenuItem!=CurMenuItem{
		gosub *EndLessonMenuItem_UnFocus
		CurMenuItem=SelMenuItem
		gosub *EndLessonMenuItem_Focus
	}else{
		redraw 0
		y=CurMenuItem*112+256
		gmode 1
		pos 528+MenuItemAniPos.j,y
		gcopy BF_BACKGROUND,528+MenuItemAniPos.j,y,96,96
		if j<MAX_MENU_ANI_CNT{j++}else{j=0}
		gmode 4,,,MenuOpacity:color
		pos 528+MenuItemAniPos.j,y:gcopy BF_ENDMENU,96,CurMenuItem*96,96,96
		redraw 1,524,y,104,96
	}

	if BlinkCnt=0{
		rnd n,100
		if n=0{
			gosub *BlinkCharacter
			BlinkCnt=1
		}
	}else{
		BlinkCnt++
		if BlinkCnt=3{
			gosub *DrawCharacter
			BlinkCnt=0
		}
	}
	loop

	if BlinkCnt>0:gosub *DrawCharacter

	redraw 0
	y=CurMenuItem*112+256
	gmode 1
	pos 528+MenuItemAniPos.j,y
	gcopy BF_BACKGROUND,528+MenuItemAniPos.j,y,96,96
	gmode 4,,,MenuOpacity
	color
	pos 528,y:gcopy BF_ENDMENU,192,CurMenuItem*96,96,96
	redraw 1,524,y,104,96

	if Sound & SoundLoaded.SB_MENUSELECTED:snd SB_MENUSELECTED

	y=1-CurMenuItem*112+256
	pos 528,y
	repeat 4
	redraw 0
	gmode 1:gcopy BF_BACKGROUND,528,y,96,96
	if cnt<=2{
		gmode 4,,,3-cnt*MenuOpacity/4
		gcopy BF_ENDMENU,0,1-CurMenuItem*96,96,96
	}
	redraw 1,528,y,96,96
	await 50
	loop

	wait 10

	y=CurMenuItem*112+256
	pos 528,y
	repeat 4
	redraw 0
	gmode 1:gcopy BF_BACKGROUND,528,y,96,96
	if cnt<=2{
		gmode 4,,,3-cnt*MenuOpacity/4
		gcopy BF_ENDMENU,192,CurMenuItem*96,96,96
	}
	redraw 1,528,y,96,96
	await 50
	loop

	retval=CurMenuItem
	return

*EndLessonMenuItem_UnFocus
	redraw 0
	y=CurMenuItem*112+256
	gmode 1
	pos 528+MenuItemAniPos.j,y
	gcopy BF_BACKGROUND,528+MenuItemAniPos.j,y,96,96
	gmode 4,,,MenuOpacity:color
	pos 528,y:gcopy BF_ENDMENU,0,CurMenuItem*96,96,96
	redraw 1,524,y,104,96
	return

*EndLessonMenuItem_Focus
	redraw 0
	y=CurMenuItem*112+256
	pos 528,y
	gmode 1
	gcopy BF_BACKGROUND,528,y,96,96
	gmode 4,,,MenuOpacity
	gcopy BF_ENDMENU,96,CurMenuItem*96,96,96
	j=0
	return



*InitLesson
	TypedCharsCnt=0:TypedWordsCnt=0
	MissTypedCnt=0
	memset MissTypedKey,0,95*4
	TimeCnt=0
	CurWord=""
	BlinkCnt=0
	return

*LessonMain
	if ShowTimeCnt & (TimeCnt=0){
		redraw 0
		gmode 2
		;"b"
		pos 592,208:gcopy BF_MESSAGES,240,160,32,32
		if TimeLimit{
			;""
			pos 528,128:gcopy BF_MESSAGES,272,160,56,32
			CntDrawTime=TimeLimit
			gosub *DrawTimeCnt
			CntDrawTimeCnt-=100
		}else{
			CntDrawTime=0
			gosub *DrawTimeCnt
			CntDrawTime+=100
		}
		redraw 1,528,128,96,112
	}
	if ShowWordCnt{
		redraw 0
		gmode 2
		;""
		pos 528,128:gcopy BF_MESSAGES,272,160,56,32
		;"P" or ""
		pos 560,208:gcopy BF_MESSAGES,260,WordCntType*32+280,64,32
		gosub *DrawWordCnt
		redraw 1,528,128,96,112
	}

	notesel TypeWords
	notemax TypeWordsNum
	CurWordNo=0
	if TimeCnt=0:StartTimeCount:else:RestartTimeCount

*NextWord
	notesel TypeWords
	noteget CurWord,CurWordNo
	strlen CurWordLen,CurWord

	;For Debug
	if CurWordLen=0{
		dialog "No Word",1,"Error"
		goto *Exit
	}
	if CurWordLen>MAX_WORD_LENGTH{
		dialog "Over Word Length",1,"Error"
		goto *Exit
	}

	repeat CurWordLen
	peek n,CurWord,cnt

	;For Debug
	if (n<0x20) | (n>0x7E){
		dialog "Invalid character in - \""+CurWord+"\"",1,"Error"
		goto *Exit
	}

	CurWord_CharCode.cnt=n
	i=n-32
	CurWord_KeyCode.cnt=CharKeyCode.i
	loop

	WordPos.Left=480-(FONT_WIDTH*CurWordLen)/2+24
	if ShowKeyboard{
		WordPos.Top=192-FONT_HEIGHT/2+80
	}else{
		WordPos.Top=384-FONT_HEIGHT/2+80
	}

	redraw 0
	gmode 2
	repeat CurWordLen
	pos cnt*FONT_WIDTH+WordPos.Left,WordPos.Top
	gcopy BF_FONT,CurWord_CharCode.cnt-32*FONT_WIDTH,0,FONT_WIDTH,FONT_HEIGHT
	loop
	redraw 1,WordPos.Left,WordPos.Top,FONT_WIDTH*CurWordLen,FONT_HEIGHT

	CurCharNo=0

*NextLetter
	gmode 2
	pos CurCharNo*FONT_WIDTH+WordPos.Left,WordPos.Top
	gcopy BF_FONT,CurWord_CharCode.CurCharNo-32*FONT_WIDTH,FONT_HEIGHT,FONT_WIDTH,FONT_HEIGHT

	if ShowKeyboard{
		i=CurWord_CharCode.CurCharNo-32

		y=CharKeyBoardPos.1.i*32
		if CharKeyBoardPos.1.i<=3{
			x=CharKeyBoardPos.0.i*32
			if CharKeyBoardPos.1.i=0{x+=32}
			if CharKeyBoardPos.1.i=1{x+=48}
			if CharKeyBoardPos.1.i=2{x+=60}
			if CharKeyBoardPos.1.i=3{x+=76}
			pos x+24,y+288
			gcopy BF_KEYBOARD,x,160+y,32,32
		}else{
			pos 196,y+288
			gcopy BF_KEYBOARD,172,160+y,308,32
		}

		if CharKeyBoardPos.1.i<=3{
			if CharKeyBoardPos.0.i<=3{
				x=CharKeyBoardPos.0.i*32
				x.1=CharKeyBoardPos.0.i
			}
			if CharKeyBoardPos.0.i=4{x=3*32:x.1=3}
			if CharKeyBoardPos.0.i=5{x=352:x.1=3}
			if (CharKeyBoardPos.0.i>=6) & (CharKeyBoardPos.0.i<=9){
				x=CharKeyBoardPos.0.i-6*32+352
				x.1=9-CharKeyBoardPos.0.i
			}
			if CharKeyBoardPos.0.i>=10{
				x=32*3+352:x.1=0
			}
			if ((CurWord_CharCode.CurCharNo='6') | (CurWord_CharCode.CurCharNo='&')) & (TypeHand6=TH_LEFT){
				x=3*32
			}
			pos x+24,288+136
			gcopy BF_HAND,x.1*32,56,32,56
		}else{
			pos 152,288+136
			gcopy BF_HAND,128,56,32,56
			pos 344,288+136
			gcopy BF_HAND,128,56,32,56
		}
	}

	onkey *HitKey

*KeyLoop
	if ShowTimeCnt{
		if TimeLimit{
			if TimeLimit-TimeCnt<=CntDrawTime{
				gosub *DrawTimeCnt
				CntDrawTime-=100
				if TimeCnt>=TimeLimit{
					onkey 0:StopTimeCount
					TimeCnt=TimeLimit
					if BlinkCnt>0{gosub *DrawCharacter:BlinkCnt=0}
					retval=LESSON_END:return
				}
			}
		}else{
			if TimeCnt>=CntDrawTime{
				gosub *DrawTimeCnt
				CntDrawTime+=100
			}
		}
	}
	if BlinkCnt=0{
		rnd n,100
		if n=0{
			gosub BlinkCharacter
			BlinkCnt=1
		}
	}else{
		BlinkCnt++
		if BlinkCnt=3{
			gosub *DrawCharacter
			BlinkCnt=0
		}
	}
	await 50:GetTimeCount TimeCnt
	goto *KeyLoop

*HitKey
	if (iparam=VK_SHIFT) | (iparam=VK_CTRL):goto *KeyLoop
	onkey 0
	if iparam=VK_ESCAPE:StopTimeCount:goto *PauseMenu
	if CurWord_KeyCode.CurCharNo!=iparam:goto *MissTyped
	i=CurWord_CharCode.CurCharNo
	if ((i>=0x21) & (i<=0x2B)) | ((i>=0x3C) & (i<=0x3F)) | (i>=0x7B){
		getkey n,VK_SHIFT:if n=0{goto *MissTyped}
	}
	if ((i>=0x2C) & (i<=0x2F)) | (i=0x3A) | (i=0x3B) | (i=0x40) | ((i>=0x5B) & (i<=0x5E)){
		getkey n,VK_SHIFT:if n{goto *MissTyped}
	}

	TypedCharsCnt++

	redraw 0
	pos CurCharNo*FONT_WIDTH+WordPos.Left,WordPos.Top
	gmode 1
	gcopy BF_BACKGROUND,CurCharNo*FONT_WIDTH+WordPos.Left,WordPos.Top,FONT_WIDTH,FONT_HEIGHT
	gmode 4,,,128:color
	gcopy BF_FONT,CurWord_CharCode.CurCharNo-32*FONT_WIDTH,0,FONT_WIDTH,FONT_HEIGHT
	redraw 1,CurCharNo*FONT_WIDTH+WordPos.Left,WordPos.Top,FONT_WIDTH,FONT_HEIGHT

	if ShowKeyboard{
		gmode 2
		i=CurWord_CharCode.CurCharNo-32
		y=CharKeyBoardPos.1.i*32
		if CharKeyBoardPos.1.i<=3{
			x=CharKeyBoardPos.0.i*32
			if CharKeyBoardPos.1.i=0{x+=32}
			if CharKeyBoardPos.1.i=1{x+=48}
			if CharKeyBoardPos.1.i=2{x+=60}
			if CharKeyBoardPos.1.i=3{x+=76}
			pos x+24,y+288
			gcopy BF_KEYBOARD,x,y,32,32
		}else{
			pos 196,y+288
			gcopy BF_KEYBOARD,172,y,308,32
		}

		if CharKeyBoardPos.1.i<=3{
			if CharKeyBoardPos.0.i<=3{
				x=CharKeyBoardPos.0.i*32
				x.1=CharKeyBoardPos.0.i
			}
			if CharKeyBoardPos.0.i=4{x=3*32:x.1=3}
			if CharKeyBoardPos.0.i=5{x=352:x.1=3}
			if (CharKeyBoardPos.0.i>=6) & (CharKeyBoardPos.0.i<=9){
				x=CharKeyBoardPos.0.i-6*32+352
				x.1=9-CharKeyBoardPos.0.i
			}
			if CharKeyBoardPos.0.i>=10{
				x=32*3+352:x.1=0
			}
			if ((CurWord_CharCode.CurCharNo='6') | (CurWord_CharCode.CurCharNo='&')) & (TypeHand6=TH_LEFT){
				x=3*32
			}
			pos x+24,288+136
			gcopy BF_HAND,x.1*32,0,32,56
		}else{
			pos 152,288+136
			gcopy BF_HAND,128,0,32,56
			pos 344,288+136
			gcopy BF_HAND,128,0,32,56
		}
	}

	CurCharNo++
	if CurCharNo<CurWordLen:goto *NextLetter

	TypedWordsCnt++
	CurWordNo++

	if CurWordLen=1{
		StopTimeCount:await 100:RestartTimeCount
	}else{
		if Sound & SoundLoaded.SB_WORDTYPED{snd SB_WORDTYPED}
	}

	pos WordPos.Left,WordPos.Top
	gmode 1
	gcopy BF_BACKGROUND,WordPos.Left,WordPos.Top,CurWordLen*FONT_WIDTH,FONT_HEIGHT
	if (WordPos.Left<152) & (WordPos.Top<208){
		gmode 4,,,MenuOpacity/2:color
		gcopy BF_MAINMENU,768-(152-WordPos.Left),CurMainMenuItem+1*128-(208-WordPos.Top),152-WordPos.Left,208-WordPos.Top
	}

	if ShowWordCnt:gosub *DrawWordCnt

	if CurWordNo=TypeWordsNum{
		StopTimeCount
		if BlinkCnt>0{gosub *DrawCharacter:BlinkCnt=0}
		retval=LESSON_END:return
	}
	goto *NextWord

*MissTyped
	MissTypedCnt++
	n=CurWord_CharCode.CurCharNo-32:MissTypedKey.n++

	gmode 2
	pos CurCharNo*FONT_WIDTH+WordPos.Left,WordPos.Top
	gcopy BF_FONT,CurWord_CharCode.CurCharNo-32*FONT_WIDTH,FONT_HEIGHT*2,FONT_WIDTH,FONT_HEIGHT

	if ShowKeyboard & (iparam>=32) & (iparam<=126){
		i=iparam-32
		y=CharKeyBoardPos.1.i*32
		if CharKeyBoardPos.1.i<=3{
			x=CharKeyBoardPos.0.i*32
			if CharKeyBoardPos.1.i=0{x+=32}
			if CharKeyBoardPos.1.i=1{x+=48}
			if CharKeyBoardPos.1.i=2{x+=60}
			if CharKeyBoardPos.1.i=3{x+=76}
			pos x+24,y+288
			if iparam!=CurWord_KeyCode.CurCharNo{
				gcopy BF_KEYBOARD,x,160+y,32,32
			}else{
				gcopy BF_KEYBOARD,x,y,32,32
			}
		}else{
			pos 196,y+288
			if iparam!=CurWord_KeyCode.CurCharNo{
				gcopy BF_KEYBOARD,172,160+y,308,32
			}else{
				gcopy BF_KEYBOARD,172,y,308,32
			}
		}
	}

	if Sound & SoundLoaded.SB_MISSTYPED:snd SB_MISSTYPED

	await 100:GetTimeCount TimeCnt

	pos CurCharNo*FONT_WIDTH+WordPos.Left,WordPos.Top
	gcopy BF_FONT,CurWord_CharCode.CurCharNo-32*FONT_WIDTH,FONT_HEIGHT,FONT_WIDTH,FONT_HEIGHT

	if ShowKeyboard & (iparam>=32) & (iparam<=126){
		if CharKeyBoardPos.1.i<=3{
			pos x+24,y+288
			if iparam!=CurWord_KeyCode.CurCharNo{
				gcopy BF_KEYBOARD,x,y,32,32
			}else{
				gcopy BF_KEYBOARD,x,160+y,32,32
			}
		}else{
			pos 196,y+288
			if iparam!=CurWord_KeyCode.CurCharNo{
				gcopy BF_KEYBOARD,172,y,308,32
			}else{
				gcopy BF_KEYBOARD,172,160+y,308,32
			}
		}
	}

	onkey 1
	goto *KeyLoop

*HideCurWord
	gmode 1
	pos WordPos.Left,WordPos.Top
	gcopy BF_BACKGROUND,WordPos.Left,WordPos.Top,FONT_WIDTH*CurWordLen,FONT_HEIGHT
	return

*DrawTimeCnt
	redraw 0
	gmode 1
	pos 552,164:gcopy BF_BACKGROUND,552,164,72,40
	gmode 2
	n=CntDrawTime/100
	repeat
	pos 600-(cnt*24),164:gcopy BF_MESSAGES,n\10*24,160,24,40
	n=n/10:if n=0:break
	loop
	redraw 1,552,164,72,40
	return

*DrawWordCnt
	redraw 0
	gmode 1
	pos 552,164:gcopy BF_BACKGROUND,552,164,72,40
	gmode 2
	n=TypeWordsAll-TypedWordsCnt
	repeat
	pos 600-(cnt*24),164:gcopy BF_MESSAGES,n\10*24,160,24,40
	n=n/10:if n=0:break
	loop
	redraw 1,552,164,72,40
	return

*HideTimeCnt

*HideWordCnt
	gmode 1
	pos 528,128:gcopy BF_BACKGROUND,528,128,96,112
	return


*PauseMenu
	GetCurMessage s

	buffer BF_TEMP,264,128,COLORMODE
	gmode 1:gcopy MainWindowID,132,208,264,128
	gsel MainWindowID
	CurMenuItem=0
	redraw 0
	gmode 4,,,MenuOpacity:color
	repeat 2,1
	pos 136,cnt*44+208:gcopy BF_MENU,0,cnt*40,256,40
	loop
	gosub *PauseMenuItem_Focus
	redraw 1,136,208,256,128

	CurKey=0
	mx=-1:my=-1
	;BlinkCnt=0

	repeat
	await 50

	stick n,0x040A,1
	if n&0x10:CurKey=VK_SPACE:break
	if n&0x20:CurKey=VK_RETURN:break
	if n&0x100:CurKey=VK_LBUTTON:break
	SelMenuItem=CurMenuItem
	if n&0x0A=0x02{	;Up and !Down
		if CurKey=VK_UP{KeyRepeatCnt++}else{CurKey=VK_UP:KeyRepeatCnt=0}
		if KeyRepeatCnt\3=0{
			if SelMenuItem>=1{
				SelMenuItem--
			}
		}
	}else{
		if CurKey=VK_UP{CurKey=0}
	}
	if n&0x0A=0x08{	;Down and !Up
		if CurKey=VK_DOWN{KeyRepeatCnt++}else{CurKey=VK_DOWN:KeyRepeatCnt=0}
		if KeyRepeatCnt\3=0{
			if SelMenuItem<=1{
				SelMenuItem++
			}
		}
	}else{
		if CurKey=VK_DOWN{CurKey=0}
	}
	if n=0x400{	;Tab
		if CurKey=VK_TAB{KeyRepeatCnt++}else{CurKey=VK_TAB:KeyRepeatCnt=0}
		if KeyRepeatCnt\3=0{
			SelMenuItem=SelMenuItem+1\4
		}
	}else{
		if CurKey=VK_TAB{CurKey=0}
	}

	if (mousex!=mx) | (mousey!=my){
		i=-1
		repeat 3
		y=cnt*44+208
		if (mousex>=136) & (mousex<392) & (mousey>=y) & (mousey<(y+40)){
			i=cnt:break
		}
		loop
		if (i>=0) & (i!=SelMenuItem){
			SelMenuItem=i
		}
		mx=mousex:my=mousey
	}

	if SelMenuItem!=CurMenuItem{
		gosub *PauseMenuItem_UnFocus
		CurMenuItem=SelMenuItem
		gosub *PauseMenuItem_Focus
	}else{
		redraw 0
		y=CurMenuItem*44+208
		gmode 1
		pos 136+MenuItemAniPos.j,y
		gcopy BF_TEMP,4+MenuItemAniPos.j,CurMenuItem*44,256,40
		if j<MAX_MENU_ANI_CNT{j++}else{j=0}
		gmode 4,,,MenuOpacity:color
		pos 136+MenuItemAniPos.j,y
		gcopy BF_MENU,256,CurMenuItem*40,256,40
		redraw 1,132,y,264,40
	}

	if BlinkCnt=0{
		rnd n,100
		if n=0{
			gosub *BlinkCharacter
			BlinkCnt=1
		}
	}else{
		BlinkCnt++
		if BlinkCnt=3{
			gosub *DrawCharacter
			BlinkCnt=0
		}
	}
	loop

	if BlinkCnt>0:gosub *DrawCharacter:BlinkCnt=0

	redraw 0
	y=CurMenuItem*44+208
	gmode 1
	pos 136+MenuItemAniPos.j,y
	gcopy BF_TEMP,4+MenuItemAniPos.j,CurMenuItem*44,256,40
	gmode 4,,,MenuOpacity
	color
	pos 136,y:gcopy BF_MENU,512,CurMenuItem*40,256,40
	redraw 1,132,y,264,40

	if Sound & SoundLoaded.SB_MENUSELECTED:snd SB_MENUSELECTED

	wait 10

	repeat
	getkey n,CurKey:if n=0:break
	wait 5
	loop
	CurKey=0

	if CurMenuItem=0{
		gmode 1
		pos 136,208:gcopy BF_TEMP,4,0,256,128
		DrawMessage s

		onkey 1:RestartTimeCount
		goto *KeyLoop
	}

	repeat 4
	redraw 0
	gmode 1
		repeat 3
		if cnt!=CurMenuItem{
			pos 136,cnt*44+208:gcopy BF_TEMP,4,cnt*44,256,40
		}
		loop
	if cnt<=2{
		gmode 4,,,3-cnt*MenuOpacity/4
		repeat 3
		if cnt!=CurMenuItem{
			pos 136,cnt*44+208:gcopy BF_MENU,512,cnt*40,256,40
		}
		loop
	}
	redraw 1,136,208,256,128
	await 50
	loop
	repeat 4
	redraw 0
	gmode 1
	pos 136,CurMenuItem*44+208:gcopy BF_TEMP,4,CurMenuItem*44,256,40
	if cnt<=2{
		gmode 4,,,3-cnt*MenuOpacity/4
		gcopy BF_MENU,512,CurMenuItem*40,256,40
	}
	redraw 1,136,CurMenuItem*44+208,256,40
	await 50
	loop

	redraw 0
	DrawMessage ""
	gosub *HideCurWord
	if ShowTimeCnt:gosub *HideTimeCnt
	if ShowWordCnt:gosub *HideWordCnt

	if CurMenuItem=1{
		if ShowKeyboard{gosub *DrawKeyboard}
		redraw 1
		retval=LESSON_RESTART:return
	}

	redraw 1
	if ShowKeyboard{gosub *DownKeyboard}
	retval=LESSON_BREAK
	return

*PauseMenuItem_Focus
	redraw 0
	y=CurMenuItem*44+208
	gmode 1:pos 136,y:gcopy BF_TEMP,4,CurMenuItem*44,256,40
	gmode 4,,,MenuOpacity:color
	pos 136,y:gcopy BF_MENU,256,CurMenuItem*40,256,40
	redraw 1,136,y,256,40
	j=0
	if CurMenuItem=0{
		DrawMessage "KĊJ܂B"
	}
	if CurMenuItem=1{
		DrawMessage "Kŏ蒼܂B"
	}
	if CurMenuItem=2{
		DrawMessage "K𒆎~āAÕj[ɖ߂܂B"
	}
	return

*PauseMenuItem_UnFocus
	redraw 0
	y=CurMenuItem*44+208
	gmode 1
	pos 136+MenuItemAniPos.j,y
	gcopy BF_TEMP,4+MenuItemAniPos.j,CurMenuItem*44,256,40
	gmode 4,,,MenuOpacity:color
	pos 136,y:gcopy BF_MENU,0,CurMenuItem*40,256,40
	redraw 1,132,y,264,40
	return



*DrawResult
	buffer BF_TEMP,480,160,COLORMODE
	boxf 0,32,479,159

	gmode 2
	y=32

	;ł̐
	pos 0,y:gcopy BF_MESSAGES,0,0,220,32
	pos 420,y:gcopy BF_MESSAGES,260,0,60,32
	n=TypedCharsCnt
	repeat
	pos 388-(cnt*32),y:gcopy BF_MESSAGES,n\10*32,128,32,32
	n=n/10:if n=0:break
	loop
	y+=32

	;~X
	pos 0,y:gcopy BF_MESSAGES,0,32,220,32
	pos 448,y:gcopy BF_MESSAGES,288,32,32,32
	n=MissTypedCnt
	repeat
	pos 416-(cnt*32),y:gcopy BF_MESSAGES,n\10*32,128,32,32
	n=n/10:if n=0:break
	loop
	y+=32

	;ŗ
	pos 0,y:gcopy BF_MESSAGES,0,64,220,32
	pos 448,y:gcopy BF_MESSAGES,288,64,32,32
	if TypedCharsCnt+MissTypedCnt>0{
		CalcCorrectness n,TypedCharsCnt,MissTypedCnt
	}else{
		n=0
	}
	x=416
	repeat
	pos x,y:gcopy BF_MESSAGES,n\10*32,128,32,32
	if cnt=1{
		x-=16
		pos x,y:gcopy BF_MESSAGES,320,128,16,32
	}
	n=n/10:if (n=0) & (cnt>=2):break
	x-=32
	loop
	y+=32

	;σ^Cvx
	pos 0,y:gcopy BF_MESSAGES,0,96,220,32
	pos 408,y:gcopy BF_MESSAGES,248,96,72,32
	CalcAverage n,TypedCharsCnt,TimeCnt
	x=376
	repeat
	pos x,y:gcopy BF_MESSAGES,n\10*32,128,32,32
	if cnt=1{
		x-=16
		pos x,y:gcopy BF_MESSAGES,320,128,16,32
	}
	n=n/10:if (n=0) & (cnt>=2):break
	x-=32
	loop

	if ShowKeyboard:y=100:else:y=196
	i=0
	repeat 4
	gsel BF_TEMP:pos 0,0:gcopy MainWindowID,24,y,480,32
	gsel MainWindowID
	pos 24,y
		repeat 5
		redraw 0
		if cnt{
			gmode 1
			gcopy BF_TEMP,0,0,480,32
		}
		gmode 4,,,256*(cnt+1)/5
		gcopy BF_TEMP,0,i*32+32,480,32
		redraw 1,24,y,480,32
		await 50
		loop
	y+=40
	i++
	loop

	return

*HideResult
	gmode 1
	if ShowKeyboard:y=100:else:y=196
	pos 24,y
	gcopy BF_BACKGROUND,24,y,480,152
	return



*FadeKeyboard
	gmode 4,,,128
	pos 24,288:gcopy BF_BACKGROUND,24,288,480,192
	return

*DrawMissTypedKey
	redraw 0
	gmode 2
	repeat 95
	if MissTypedKey.cnt>=2{
		y=CharKeyBoardPos.1.cnt*32
		if CharKeyBoardPos.1.cnt<=3{
			x=CharKeyBoardPos.0.cnt*32
			if CharKeyBoardPos.1.cnt=0{x+=32}
			if CharKeyBoardPos.1.cnt=1{x+=48}
			if CharKeyBoardPos.1.cnt=2{x+=60}
			if CharKeyBoardPos.1.cnt=3{x+=76}
			pos x+24,y+288:gcopy BF_KEYBOARD,x,y+160,32,32
		}else{
			pos 196,y+288:gcopy BF_KEYBOARD,172,y+160,308,32
		}
	}
	loop
	redraw 1,24,288,480,192

	return



*DrawKeyboard
	gmode 2
	pos 24,288:gcopy BF_KEYBOARD,0,0,480,160
	pos 24,424:gcopy BF_HAND,0,0,160,56
	repeat 5
	pos cnt*32+344:gcopy BF_HAND,4-cnt*32,0,32,56
	loop
	return

*HideKeyboard
	gmode 1
	pos 24,288:gcopy BF_BACKGROUND,24,288,480,192
	return

*UpKeyboard
	n=10
	y.2=0,0
	repeat n
	redraw 0
	if cnt{
		gmode 1
		pos 24,y
		gcopy BF_BACKGROUND,24,y,480,y.1
	}
	y=480-(192*(cnt+1)/n)
	y.1=480-y
	if y.2<160{
		y.2=y.1:if y.2>160{y.2=160}
	}
	gmode 2
	pos 24,y:gcopy BF_KEYBOARD,0,0,480,y.2
	if (y.1>136) & (y.3<56){
		y.3=y.1-136:if y.3>56{y.3=56}
	}
	if y.3{
		pos 24,y+136:gcopy BF_HAND,0,0,160,y.3
		repeat 5
		pos 32*cnt+344,y+136:gcopy BF_HAND,4-cnt*32,0,32,y.3
		loop
	}
	redraw 1,24,y,480,y.1
	await 50
	loop
	return

*DownKeyboard
	n=10
	y=288,192,0,0
	repeat n
	redraw 0
	pos 24,y
	gmode 1:gcopy BF_BACKGROUND,24,y,480,y.1
	y=192*(cnt+1)/n+288
	y.1=480-y
	y.2=y.1:if y.2>160:y.2=160
	if y.2{
		gmode 2
		pos 24,y:gcopy BF_KEYBOARD,0,0,480,y.2
	}
	y.3=y.1-136
	if y.3>=1{
		gmode 2
		pos 24,y+136:gcopy BF_HAND,0,0,160,y.3
		repeat 5
		pos 32*cnt+344,y+136:gcopy BF_HAND,4-cnt*32,0,32,y.3
		loop
	}
	redraw 1
	await 50
	loop
	return



*Options
	buffer BF_TEMP,128,128,COLORMODE
	gmode 1:gcopy BF_BACKGROUND,24,80,128,128
	gsel BF_BACKGROUND:gmode 1
	pos 24,80:gcopy MainWindowID,24,80,128,128
	gsel MainWindowID
	color
	x=0,0
	x.3=0
	n=10
	repeat n
	redraw 0
	gmode 1
	if cnt{
		pos x,126:gcopy BF_BACKGROUND,x,126,x.1,260
		pos x.2,368:gcopy BF_BACKGROUND,x.2,368,x.3,96
	}
	gmode 4,,,MenuOpacity*(cnt+1)/n
	if x.1<256{
		x.1=368*(cnt+1)/n:if x.1>256{x=x.1-256:x.1=256}
	}else{
		x=368*(cnt+1)/n-256
	}
		repeat 6
		pos x,cnt*44+126
		gcopy BF_MENU,256-x.1,cnt*40+OPTIONS_MENU_POS,x.1,40
		loop
	x.2=640-(112*(cnt+1)/n)
	if x.3<96{
		x.3=640-x.2:if x.3>96{x.3=96}
	}
	pos x.2,368:gcopy BF_ENDMENU,0,192,x.3,96
	redraw 1
	await 50
	loop
	if WallPaperName=""{
		redraw 0
		gmode 1
		pos 112,170
		gcopy BF_BACKGROUND,112,170,256,40
		gmode 4,,,MenuOpacity/2
		pos 112,170:gcopy BF_MENU,0,OPTIONS_MENU_POS+40,256,40
		redraw 1,112,170,256,40
	}
	if FullScreenOnly{
		redraw 0
		gmode 3,,,192
		pos 112,214:gcopy BF_BACKGROUND,112,214,256,40
		redraw 1
	}

	gmode 2
	pos 376,218:gcopy BF_MESSAGES,WindowMode*128,248,128,32
	pos 376,262:gcopy BF_MESSAGES,1-Sound*128,280,128,32
	pos 376,306:gcopy BF_MESSAGES,1-Music*128,280,128,32
	pos 376,350:gcopy BF_MESSAGES,TypeHand6*128,312,128,32

	CurMenuItem=CurOptionMenuItem
	gosub *OptionMenuItem_Focus

	CurKey=0
	mx=-1:my=-1
	BlinkCnt=0

	repeat
	await 50

	stick n,0x040A,1
	if n&0x10:CurKey=VK_SPACE
	if n&0x20:CurKey=VK_RETURN
	if n&0x100:CurKey=VK_LBUTTON
	if n&0x130{
		if CurMenuItem=6{break}
		gosub *ChangeOption
	}
	if n&0x80{
		gosub *OptionMenuItem_UnFocus
		CurMenuItem=6
		CurKey=VK_ESCAPE:break
	}
	SelMenuItem=CurMenuItem
	if n&0x0A=0x02{	;Up and !Down
		if CurKey=VK_UP{KeyRepeatCnt++}else{CurKey=VK_UP:KeyRepeatCnt=0}
		if KeyRepeatCnt\3=0{
			if (SelMenuItem>=1) & (SelMenuItem<=5){
				SelMenuItem--
				if (SelMenuItem=2) & FullScreenOnly{
					SelMenuItem--
				}
				if (SelMenuItem=1) & (WallPaperName=""){
					SelMenuItem--
				}
			}
		}
	}else{
		if CurKey=VK_UP{CurKey=0}
	}
	if n&0x0A=0x08{	;Down and !Up
		if CurKey=VK_DOWN{KeyRepeatCnt++}else{CurKey=VK_DOWN:KeyRepeatCnt=0}
		if KeyRepeatCnt\3=0{
			if SelMenuItem<=4{
				SelMenuItem++
				if (SelMenuItem=1) & (WallPaperName=""){
					SelMenuItem++
				}
				if (SelMenuItem=2) & FullScreenOnly{
					SelMenuItem++
				}
			}
		}
	}else{
		if CurKey=VK_DOWN{CurKey=0}
	}
	if n&0x05=0x01{	;Left and !Right
		CurKey=VK_LEFT
		if SelMenuItem=6{
			SelMenuItem=CurOptionMenuItem
		}
	}else{
		if CurKey=VK_LEFT{CurKey=0}
	}
	if n&0x05=0x04{	;Right and !Left
		CurKey=VK_RIGHT
		if SelMenuItem<=5{
			SelMenuItem=6
		}
	}else{
		if CurKey=VK_RIGHT{CurKey=0}
	}
	if n=0x400{	;Tab
		if CurKey=VK_TAB{KeyRepeatCnt++}else{CurKey=VK_TAB:KeyRepeatCnt=0}
		if KeyRepeatCnt\3=0{
			SelMenuItem=SelMenuItem+1\7
			if (SelMenuItem=1) & (WallPaperName=""){
				SelMenuItem++
			}
			if (SelMenuItem=2) & FullScreenOnly{
				SelMenuItem++
			}
		}
	}else{
		if CurKey=VK_TAB{CurKey=0}
	}

	if (mousex!=mx) | (mousey!=my){
		i=-1
		repeat 6
		y=cnt*44+126
		if (mousex>=112) & (mousex<368) & (mousey>=y) & (mousey<(y+40)){
			i=cnt:break
		}
		loop
		if i<0{
			if (mousex>=528) & (mousex<624) & (mousey>=368) & (mousey<464){
				i=6
			}
		}
		if ((i=1) & (WallPaperName="")) | ((i=2) & FullScreenOnly){i=-1}
		if (i>=0) & (i!=SelMenuItem){
			SelMenuItem=i
		}
		mx=mousex:my=mousey
	}

	if SelMenuItem!=CurMenuItem{
		gosub *OptionMenuItem_UnFocus
		CurMenuItem=SelMenuItem
		if CurMenuItem<=5{CurOptionMenuItem=CurMenuItem}
		gosub *OptionMenuItem_Focus
	}else{
		redraw 0
		gmode 1
		color
		if CurMenuItem<=5{
			y=CurOptionMenuItem*44+126
			pos 112+MenuItemAniPos.j,y
			gcopy BF_BACKGROUND,112+MenuItemAniPos.j,y,256,40
			if j<MAX_MENU_ANI_CNT{j++}else{j=0}
			gmode 4,,,MenuOpacity
			pos 112+MenuItemAniPos.j,y
			gcopy BF_MENU,256,CurMenuItem*40+OPTIONS_MENU_POS,256,40
			redraw 1,108,y,264,40
		}else{
			pos 528+MenuItemAniPos.j,368
			gcopy BF_BACKGROUND,528+MenuItemAniPos.j,368,96,96
			if j<MAX_MENU_ANI_CNT{j++}else{j=0}
			gmode 4,,,MenuOpacity
			pos 528+MenuItemAniPos.j,368:gcopy BF_ENDMENU,96,192,96,96
			redraw 1,524,368,104,96
		}
	}

	if BlinkCnt=0{
		rnd n,100
		if n=0{
			gosub *BlinkCharacter
			BlinkCnt=1
		}
	}else{
		BlinkCnt++
		if BlinkCnt=3{
			gosub *DrawCharacter
			BlinkCnt=0
		}
	}
	loop

	if BlinkCnt>0:gosub *DrawCharacter

	redraw 0
	gmode 1
	pos 528+MenuItemAniPos.j,368
	gcopy BF_BACKGROUND,528+MenuItemAniPos.j,368,96,96
	gmode 4,,,MenuOpacity
	color
	pos 528,368:gcopy BF_ENDMENU,192,192,96,96
	redraw 1,524,368,104,96

	if Sound & SoundLoaded.SB_MENUSELECTED:snd SB_MENUSELECTED

	gmode 1
	pos 376,218:gcopy BF_BACKGROUND,376,218,128,164

	i=0
	repeat 4
	redraw 0
	gmode 1
	pos 112,126:gcopy BF_BACKGROUND,112,126,256,260
	if cnt<=2{
		repeat 6
		pos 112,cnt*44+126
		if ((cnt!=1) | (WallPaperName!="")) & ((cnt!=2) | (FullScreenOnly=FALSE)){
			gmode 4,,,3-cnt*MenuOpacity/4
		}else{
			gmode 4,,,3-cnt*MenuOpacity/8
		}
		gcopy BF_MENU,0,cnt*40+OPTIONS_MENU_POS,256,40
		loop
	}
	redraw 1,112,126,256,260
	await 50
	i++
	loop

	wait 10

	pos 528,368
	repeat 4
	redraw 0
	gmode 1:gcopy BF_BACKGROUND,528,368,96,96
	if cnt<=2{
		gmode 4,,,3-cnt*MenuOpacity/4
		gcopy BF_ENDMENU,192,192,96,96
	}
	redraw 1,528,368,96,96
	await 50
	loop

	DrawMessage ""
	gsel BF_BACKGROUND:gmode 1
	pos 24,80:gcopy BF_TEMP,0,0,128,128
	gsel MainWindowID

	goto *ReturnMainMenu

*OptionMenuItem_UnFocus
	redraw 0
	gmode 1
	color
	if CurMenuItem<=5{
		y=CurMenuItem*44+126
		pos 112+MenuItemAniPos.j,y
		gcopy BF_BACKGROUND,112+MenuItemAniPos.j,y,256,40
		gmode 4,,,MenuOpacity
		pos 112,y
		gcopy BF_MENU,0,CurMenuItem*40+OPTIONS_MENU_POS,256,40
		redraw 1,108,y,264,40
	}else{
		pos 528+MenuItemAniPos.j,368
		gcopy BF_BACKGROUND,528+MenuItemAniPos.j,368,96,96
		gmode 4,,,MenuOpacity
		pos 528,368:gcopy BF_ENDMENU,0,192,96,96
		redraw 1,524,368,104,96
	}
	return

*OptionMenuItem_Focus
	redraw 0
	gmode 2
	color
	if CurMenuItem<=5{
		y=CurMenuItem*44+126
		pos 112,y
		gcopy BF_BACKGROUND,112,y,256,40
		gmode 4,,,MenuOpacity
		pos 112,y
		gcopy BF_MENU,256,CurMenuItem*40+OPTIONS_MENU_POS,256,40
		redraw 1,112,y,256,40
	}else{
		pos 528,368
		gcopy BF_BACKGROUND,528,368,96,96
		gmode 4,,,MenuOpacity
		gcopy BF_ENDMENU,96,192,96,96
		redraw 1,528,368,96,96
	}
	j=0
	if CurMenuItem=0{
		DrawMessage "wỉ摜ύX܂B"
	}
	if CurMenuItem=1{
		DrawMessage "wỉ摜W̉摜ɖ߂܂B"
	}
	if CurMenuItem=2{
		DrawMessage "EBhE\ƑSʕ\؂ւ܂B"
	}
	if CurMenuItem=3{
		DrawMessage "ʉ炷炳Ȃw肵܂B"
	}
	if CurMenuItem=4{
		DrawMessage "y炷炳Ȃw肵܂B"
	}
	if CurMenuItem=5{
		DrawMessage "\"6\"̃L[Eőłőłw肵܂B"
	}
	if CurMenuItem=6{
		DrawMessage "Õj[ɂǂ܂B"
	}
	return

*ChangeOption
	if BlinkCnt>0:gosub *DrawCharacter

	redraw 0
	gmode 1
	y=CurOptionMenuItem*44+126
	pos 112+MenuItemAniPos.j,y
	gcopy BF_BACKGROUND,112+MenuItemAniPos.j,y,256,40
	;if y<208{
	;	y.1=128-(y-80):if y.1>40{y.1=40}
	;	gcopy BF_TEMP,88+MenuItemAniPos.j,y-80,128-(88+MenuItemAniPos.j),y.1
	;}
	gmode 4,,,MenuOpacity
	color
	pos 112,y
	gcopy BF_MENU,512,CurMenuItem*40+OPTIONS_MENU_POS,256,40
	redraw 1,108,y,264,40

	if CurOptionMenuItem=0{
		gosub *BrowseWallPaper
	}
	if CurOptionMenuItem=1{
		WallPaperName="":IniWallPaperName=""
		buffer BF_TEMP,WINDOW_WIDTH,WINDOW_HEIGHT,COLORMODE
		picload DEFAULT_WALLPAPER_NAME
		gosub *ChangeWallPaper
		CurMenuItem=0:CurOptionMenuItem=0
	}
	if CurOptionMenuItem=2{
		gosub *ChangeScreenMode
	}
	if CurOptionMenuItem=3{
		if Sound{
			Sound=FALSE
		}else{
			gosub *LoadSounds
			Sound=TRUE
		}
		gosub *ChangeOptionParam
		wait 40
	}
	if CurOptionMenuItem=4{
		if Music{
			sndoff
			Music=FALSE
			gosub *ChangeOptionParam
			wait 40
		}else{
			gosub *LoadMusic
			if SoundLoaded.SB_BGM=FALSE{
				dialog HomeDir+"\\"+BGM_NAME+{"\nt@C܂B
					y炷߂ɂ́Ãt@CKvłB"},0,"G["
			}else{
				Music=TRUE
				snd SB_BGM
				gosub *ChangeOptionParam
				wait 40
			}
		}
	}
	if CurOptionMenuItem=5{
		if TypeHand6=TH_RIGHT{
			TypeHand6=TH_LEFT
		}else{
			TypeHand6=TH_RIGHT
		}
		gosub *ChangeOptionParam
		wait 40
	}

	repeat
	getkey n,CurKey:if n=0:break
	wait 5
	loop
	CurKey=0
	gosub *OptionMenuItem_Focus

	return

*ChangeOptionParam
	redraw 0
	y=CurOptionMenuItem*44+130
	pos 376,y
	gmode 1
	gcopy BF_BACKGROUND,376,y,128,32
	gmode 2
	if CurOptionMenuItem=2:gcopy BF_MESSAGES,WindowMode*128,248,128,32
	if CurOptionMenuItem=3:gcopy BF_MESSAGES,1-Sound*128,280,128,32
	if CurOptionMenuItem=4:gcopy BF_MESSAGES,1-Music*128,280,128,32
	if CurOptionMenuItem=5:gcopy BF_MESSAGES,TypeHand6*128,312,128,32
	redraw 1,376,y,128,32
	return

*BrowseWallPaper
	;;W̃_CAOł́AVK쐬₢킹Ă܂̖肪̂ŁA
	;;O̊֐gpB
	;dialog "bmp;*.jpg;*.mag",16,"摜t@C"
	if WallPaperName!="":getpath s,WallPaperName,8:else:s=""
	FileOpenDialog "ΉĂt@C|*.bmp;*.dib;*.rle;*.jpg;*.jpeg;*.jpe;*.mag|BMPt@C(*.bmp;*.dib;*.rle)|*.bmp;*.dib;*.rle|JPEGt@C(*.jpg;*.jpeg;*.jpe)|*.jpg;*.jpeg;*.jpe|MAGt@C(*.mag)|*.mag|SẴt@C(*.*)|*.*",WallPaperFilterIndex,s,"ǎI",OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | ((hspstat&1)*OFN_NOCHANGEDIR)
	if stat=0:return	;Cancel
	getpath s,refstr,2|16
	if (s=".bmp") | (s=".jpg") | (s=".mag"){
		gsel BF_TEMP
		skiperr 1:picload refstr:skiperr 0
	}else{
		exist refstr
		if strsize<0{
			dialog refstr+"\n摜t܂B",1,"G["
			return
		}
		if strsize=0{
			dialog refstr+"\nt@CsłB",1,"G["
			return
		}
		dim tmp,(strsize+(INT_SIZE-1))/INT_SIZE
		bload refstr,tmp,strsize
		memfile tmp
		gsel BF_TEMP
		skiperr 1
		if (s=".dib") | (s=".rle"){
			picload "MEM:a.bmp"
		}else{
			picload "MEM:a.jpg"
		}
		skiperr 0
		dim tmp,1
	}
	if err{
		dialog refstr+"\n摜ǂݍ߂܂łB",1,"G["
		gsel MainWindowID
		return
	}
	WallPaperName=refstr
	IniWallPaperName=WallPaperName

*ChangeWallPaper
	gosub *MakeBackgroundImage

	buffer BF_TEMP,WINDOW_WIDTH,WINDOW_HEIGHT,COLORMODE
	gmode 1
	pos 0,0:gcopy BF_BACKGROUND,0,0,WINDOW_WIDTH,WINDOW_HEIGHT
	gmode 4,,,MenuOpacity/2
	color
	pos 24,80:gcopy BF_MAINMENU,256,CurMainMenuItem*128,128,128
	repeat 6
	pos 112,cnt*44+126
	if ((cnt=1) & (WallPaperName="")) | ((cnt=2) & FullScreenOnly){
		gmode 4,,,MenuOpacity/2
	}else{
		gmode 4,,,MenuOpacity
	}
	gcopy BF_MENU,0,cnt*40+OPTIONS_MENU_POS,256,40
	loop
	pos 528,368:gcopy BF_ENDMENU,0,192,96,96
	gmode 2
	pos 376,218:gcopy BF_MESSAGES,WindowMode*128,248,128,32
	pos 376,262:gcopy BF_MESSAGES,1-Sound*128,280,128,32
	pos 376,306:gcopy BF_MESSAGES,1-Music*128,280,128,32
	pos 376,350:gcopy BF_MESSAGES,TypeHand6*128,312,128,32
	gosub *DrawCharacter

	gsel MainWindowID
	redraw 1
	pos 0,0
	repeat 9
	gmode 4,,,256/(10-cnt)
	gcopy BF_TEMP,0,0,WINDOW_WIDTH,WINDOW_HEIGHT
	await 100
	loop
	gmode 1
	gcopy 0,0:gcopy BF_TEMP,0,0,WINDOW_WIDTH,WINDOW_HEIGHT

	buffer BF_TEMP,128,128,COLORMODE
	gmode 1:gcopy BF_BACKGROUND,24,80,128,128
	gsel BF_BACKGROUND
	gmode 4,,,MenuOpacity/2
	color
	pos 24,80:gcopy BF_MAINMENU,256,CurMainMenuItem*128,128,128

	gsel MainWindowID
	return

*ChangeScreenMode
	if WindowMode=WMODE_FULLSCREEN{
		chgdisp
		WindowMode=WMODE_WINDOW
		gsel MainWindowID,-1
		MainWindowID=WID_WINDOW
		gosub *MainWindowInit
		gmode 1
		gcopy WID_FULLSCREEN,0,0,WINDOW_WIDTH,WINDOW_HEIGHT
		bgscr WID_FULLSCREEN,4,1,COLORMODE|2,dispx,0
	}else{
		ginfo 2
		MainWindow.Left=prmx:MainWindow.Top=prmy
		chgdisp 1
		if stat=1{
			chgdisp
			dialog "tJ[[hɂł܂łB",1,"G["
			return
		}
		if stat=2{
			dialog "ʉ𑜓x̕ύXł܂łB",1,"G["
			return
		}
		WindowMode=WMODE_FULLSCREEN
		MainWindowID=WID_FULLSCREEN
		gosub *MainWindowInit
		gmode 1
		gcopy WID_WINDOW,0,0,WINDOW_WIDTH,WINDOW_HEIGHT
		screen WID_WINDOW,4,1,COLORMODE|2,dispx,0
	}
	gsel MainWindowID
	return



*DrawCharacter
	gmode 1
	pos 532,20:gcopy BF_CHARACTER,0,112*CurCharImage,88,88
	return

*BlinkCharacter
	gmode 1
	pos 532,52:gcopy BF_CHARACTER,0,112*CurCharImage+88,88,24
	return



*MakeBackgroundImage
	gsel BF_TEMP
	x=winx:y=winy
	buffer BF_BACKGROUND,WINDOW_WIDTH,WINDOW_HEIGHT,COLORMODE
	if (x<=WINDOW_WIDTH) | (y<=WINDOW_HEIGHT){
		gmode 0
		i=0
		repeat (WINDOW_HEIGHT+y-1)/y
		if y*i+y<=WINDOW_HEIGHT{y.1=y}else{y.1=WINDOW_HEIGHT\y}
			repeat (WINDOW_WIDTH+x-1)/x
			if x*cnt+x<=WINDOW_WIDTH{x.1=x}else{x.1=WINDOW_WIDTH\x}
			pos x*cnt,y*i:gcopy BF_TEMP,0,0,x.1,y.1
			loop
		i++
		loop
	}else{
		gzoom WINDOW_WIDTH,WINDOW_HEIGHT,BF_TEMP,0,0,x,y
	}

	gsel BF_TEMP:picload "balloon.mag"
	gsel BF_BACKGROUND
	gmode 4,,,192:color
	pos 24,16:gcopy BF_TEMP,0,0,480,48
	gsel BF_TEMP:picload "charfrm.mag"
	gsel BF_BACKGROUND
	gmode 2
	pos 528,16:gcopy BF_TEMP,0,0,96,96
	return

*MainWindowInit
	if WindowMode=WMODE_WINDOW{
		screen MainWindowID,WINDOW_WIDTH,WINDOW_HEIGHT,COLORMODE,MainWindow.Left,MainWindow.Top
		title APPNAME+" - ver."+VERSIONNAME
		gsel MainWindowID,1
	}else{
		bgscr MainWindowID,WINDOW_WIDTH,WINDOW_HEIGHT,COLORMODE,0,0
	}
	return



*LoadScore
	exist ScoreFileName
	if strsize>0{
		dim tmp,2+(TIMETRIAL_NUM_LEVELS*40)+2+(MAX_HISTORY*4)
		skiperr 1
		bload ScoreFileName,tmp
		skiperr 0
		if err{
			dialog ScoreFileName+{"
				\nXRAt@C̓ǂݍ݂ł܂łB"},1,"G["
			return
		}
		if (tmp.0!=0x44535444) | (tmp.1!=0){
			dialog ScoreFileName+{"
				\nXRAt@C܂B"},1,"G["
			return
		}
		i=2
		j=0
		repeat TIMETRIAL_NUM_LEVELS
			repeat 10
			TimeTrialRanking_Score.j.cnt=tmp.i:i++
			TimeTrialRanking_Correctness.j.cnt=tmp.i:i++
			TimeTrialRanking_Date.j.cnt=tmp.i:i++
			i++		;Reserved
			loop
		j++
		loop
		LetterLessonHistoryCnt=tmp.i:i++
		repeat LetterLessonHistoryCnt
		if tmp.i=0{
			i+=LetterLessonHistoryCnt-cnt
			LetterLessonHistoryCnt=cnt
			break
		}
		LetterLessonHistory_Speed.cnt=tmp.i:i++
		LetterLessonHistory_Correctness.cnt=tmp.i:i++
		loop
		WordLessonHistoryCnt=tmp.i:i++
		repeat WordLessonHistoryCnt
		if tmp.i=0{
			;i+=WordLessonHistoryCnt-cnt
			WordLessonHistoryCnt=cnt
			break
		}
		WordLessonHistory_Speed.cnt=tmp.i:i++
		WordLessonHistory_Correctness.cnt=tmp.i:i++
		loop
	}
	return

*SaveScore
	dim tmp,2+(TIMETRIAL_NUM_LEVELS*40)+2+(LetterLessonHistoryCnt+WordLessonHistoryCnt*2)
	tmp.0=0x44535444	;Header "DTSD"
	;tmp.1=0			;Version
	i=2
	j=0
	repeat TIMETRIAL_NUM_LEVELS
		repeat 10
		tmp.i=TimeTrialRanking_Score.j.cnt:i++
		tmp.i=TimeTrialRanking_Correctness.j.cnt:i++
		tmp.i=TimeTrialRanking_Date.j.cnt:i++
		i++		;Reserved
		loop
	j++
	loop
	tmp.i=LetterLessonHistoryCnt:i++
	repeat LetterLessonHistoryCnt
	tmp.i=LetterLessonHistory_Speed.cnt:i++
	tmp.i=LetterLessonHistory_Correctness.cnt:i++;
	loop
	tmp.i=WordLessonHistoryCnt:i++
	repeat WordLessonHistoryCnt
	tmp.i=WordLessonHistory_Speed.cnt:i++
	tmp.i=WordLessonHistory_Correctness.cnt:i++
	loop
	skiperr 1
	bsave ScoreFileName,tmp
	skiperr 0
	if err{
		repeat 1
		dialog ScoreFileName+{"\nXRAt@C̕ۑɎs܂B
			ŕۑw肵܂H"},3,"G["
		if stat=7{break}	;No
		dialog "dat",17,"XRAt@C"
		if stat=0{break}	;Cancel
		skiperr 1
		bsave refstr,tmp
		skiperr 0
		if err{continue}
		loop
	}
	return



*LoadSettings
	exist HomeDir+"\\DvoraType.ini"
	if strsize>0{
		notesel tmp
		skiperr 1
		noteload HomeDir+"\\DvoraType.ini"
		skiperr 0
		if err{
			dialog "ݒt@C̓ǂݍ݂ł܂łB",1,"G["
			return
		}
		notemax n
		i=-1
		sdim prmstr,MAX_PATH
		repeat n
		noteget s,cnt
		peek n,s,0
		if (n!=0) & (n!=';'){
			if n='['{
				if s="[System]"{i=0}
				if s="[Setup]"{i=1}
			}else{
				instr j,s,"="
				if j>=0{
					getstr prmstr,s,j+1
					if strsize>0{
						poke s,j,0
						if i=1{
							if s="WindowLeft"{
								MainWindow.Left=0+prmstr
							}
							if s="WindowTop"{
								MainWindow.Top=0+prmstr
							}
							if s="FullScreen"{
								WindowMode=0+prmstr
							}
							if s="WallPaper"{
								IniWallPaperName=prmstr
							}
							if s="WallPaperFilterIndex"{
								WallPaperFilterIndex=prmstr
							}
							if s="Sound"{
								Sound=0+prmstr
							}
							if s="Music"{
								Music=0+prmstr
							}
							if s="6KeyTypeHand"{
								TypeHand6=0+prmstr
							}
							if s="MenuOpacity"{
								MenuOpacity=0+prmstr
							}
						}
					}
				}
			}
		}
		loop
	}
	return

*SaveSettings
	sdim tmp,1024
	tmp="[System]\n"
	tmp+="Version="+VERSIONNAME+"\n"
	tmp+="\n[Setup]\n"
	if WindowMode=WMODE_WINDOW{
		ginfo 2
		tmp+="WindowLeft="+prmx+"\n"
		tmp+="WindowTop="+prmy+"\n"
	}else{
		tmp+="WindowLeft="+MainWindow.Left+"\n"
		tmp+="WindowTop="+MainWindow.Top+"\n"
	}
	tmp+="FullScreen="+WindowMode+"\n"
	tmp+="WallPaper="+IniWallPaperName+"\n"
	tmp+="WallPaperFilter="+WallPaperFilterIndex+"\n"
	tmp+="Sound="+Sound+"\n"
	tmp+="Music="+Music+"\n"
	tmp+="6KeyTypeHand="+TypeHand6+"\n"
	tmp+="MenuOpacity="+MenuOpacity+"\n"
	strlen n,tmp
	skiperr 1
	bsave HomeDir+"\\DvoraType.ini",tmp,n
	skiperr 0
	if err{
		dialog "ݒt@Cۑł܂B",1,"G["
	}
	return



*LoadSounds
	;sndload48oCgȏ̃pXw肷ƕsȏɂȂ̂
	sdim tmp,MAX_PATH:tmp=curdir
	chdir HomeDir
	if SoundLoaded.SB_MENUSELECTED=FALSE{
		exist HomeDir+"\\button.wav"
		if strsize>0{
			sndload "button.wav",SB_MENUSELECTED
			SoundLoaded.SB_MENUSELECTED=TRUE
		}
	}
	if SoundLoaded.SB_WORDTYPED=FALSE{
		exist HomeDir+"\\wordtype.wav"
		if strsize>0{
			sndload "wordtype.wav",SB_WORDTYPED
			SoundLoaded.SB_WORDTYPED=TRUE
		}
	}
	if SoundLoaded.SB_MISSTYPED=FALSE{
		exist HomeDir+"\\miss.wav"
		if strsize>0{
			sndload "miss.wav",SB_MISSTYPED
			SoundLoaded.SB_MISSTYPED=TRUE
		}
	}
	if SoundLoaded.SB_TIMEUP=FALSE{
		exist HomeDir+"\\timeup.wav"
		if strsize>0{
			sndload "timeup.wav",SB_TIMEUP
			SoundLoaded.SB_TIMEUP=TRUE
		}
	}
	chdir tmp
	return

*LoadMusic
	sdim tmp,MAX_PATH;tmp=curdir
	chdir HomeDir
	if SoundLoaded.SB_BGM=FALSE{
		exist HomeDir+"\\"+BGM_NAME
		if strsize>0{
			sndload BGM_NAME,SB_BGM,1
			SoundLoaded.SB_BGM=TRUE
		}
	}
	chdir tmp
	return



*Exit
	if Music:sndoff
	if WindowMode=WMODE_FULLSCREEN:gsel MainWindowID,-1:chgdisp

;	getkey n,VK_SHIFT
;	if n=0:gosub *SaveScore
	gosub *SaveScore
	gosub *SaveSettings

	end
